' TEMPLATE

' NOTE: This file is generated automatically. Do not make modifications
' outside the designated areas; if you do, your changes may be lost.


' private helper class
class CatchModeChange extends DataEventHandler
  myVehicle as Vehicle

  sub handle(name as string, data as EventData)
    call myVehicle.setWireColor(data.getInt())
  end sub 'handle
end class 'CatchModeChange

  ' *** place user const declarations here ***
  ' *** end of user const declarations ***

class LaserWorks extends Vehicle
    sys as VehicleSystemObject
    
    HealthSensor1 as HealthSensor
    Laser2 as Laser
    Sonar1 as Sonar
    Steering1 as Steering
    Laser3 as Laser
    HealthPack1 as HealthPack
    WaypointSensor1 as WaypointSensor
    LongRangeRadar1 as LongRangeRadar
    LongRangeRadar2 as LongRangeRadar
    MediumEngine1 as MediumEngine
    Laser4 as Laser
    Laser5 as Laser
    Filter1 as Filter
    Filter2 as Filter
    Filter3 as Filter
    Filter4 as Filter
    RangeTest1 as RangeTest
    Variable1 as Variable
    Compare1 as Compare
    HealthManager1 as HealthManager
    Divide1 as Divide
    Add1 as Add
    LoopTimer1 as LoopTimer

  ' *** place vehicle data and subs here ***
  ' *** end of vehicle data and subs ***

    public function getGroup() as string
        getGroup = "Battle"
    end function 'getGroup

    public function getVer() as float
        getVer = 1.01
    end function 'getVer

    public sub Filter4_TurnOff_wires()
        ' wire Wire24 is sendto wire
        call Add1.setInput2(0)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Filter4_TurnOff_wires

    public sub Filter3_TurnOff_wires()
        ' wire Wire23 is sendto wire
        call Add1.setInput2(0)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Filter3_TurnOff_wires

    public sub LoopTimer1_Tick_wires()
        ' wire Wire22 is sendto wire
        call Sonar1.Fire()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'LoopTimer1_Tick_wires

    public sub Filter4_TurnOn_wires()
        ' wire Wire21 is sendto wire
        call Add1.setInput2(15)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Filter4_TurnOn_wires

    public sub Filter3_TurnOn_wires()
        ' wire Wire20 is sendto wire
        call Add1.setInput2(-15)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Filter3_TurnOn_wires

    public sub LongRangeRadar2_PlugIn_wires()
        ' wire Wire19 is a copy wire
        call Filter4.setFilterSocket(LongRangeRadar2.FilterPlug)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'LongRangeRadar2_PlugIn_wires

    public sub LongRangeRadar1_PlugIn_wires()
        ' wire Wire18 is a copy wire
        call Filter3.setFilterSocket(LongRangeRadar1.FilterPlug)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'LongRangeRadar1_PlugIn_wires

    public sub Divide1_Change_wires()
        ' wire Wire17 is a copy wire
        call Add1.setInput1(Divide1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Divide1_Change_wires

    public sub Add1_Change_wires()
        ' wire Wire16 is a copy wire
        call Steering1.setAngle(Add1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Add1_Change_wires

    public sub HealthManager1_UseHP1_wires()
        ' wire Wire14 is sendto wire
        call HealthPack1.Trigger()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'HealthManager1_UseHP1_wires

    public sub HealthSensor1_Change_wires()
        ' wire Wire13 is a copy wire
        call HealthManager1.setHealth(HealthSensor1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'HealthSensor1_Change_wires

    public sub Filter2_TurnOn_wires()
        ' wire Wire12 is sendto wire
        call Laser2.Fire()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Filter2_TurnOn_wires

    public sub Filter1_TurnOn_wires()
        ' wire Wire7 is sendto wire
        call Laser2.Fire()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire8 is sendto wire
        call Laser3.Fire()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire9 is sendto wire
        call Laser5.Fire()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire10 is sendto wire
        call Laser4.Fire()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Filter1_TurnOn_wires

    public sub Sonar1_PlugIn_wires()
        ' wire Wire6 is a copy wire
        call Filter1.setFilterSocket(Sonar1.FilterPlug)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire11 is a copy wire
        call Filter2.setFilterSocket(Sonar1.FilterPlug)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Sonar1_PlugIn_wires

    public sub RangeTest1_AboveRange_wires()
        ' wire Wire5 is a copy wire
        call Variable1.setInput(RangeTest1.Minimum)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'RangeTest1_AboveRange_wires

    public sub Variable1_Change_wires()
        ' wire Wire3 is a copy wire
        call WaypointSensor1.setCurrentWaypoint(Variable1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire4 is a copy wire
        call RangeTest1.setInput(Variable1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Variable1_Change_wires

    public sub Compare1_LessThan_wires()
        ' wire Wire2 is sendto wire
        call Variable1.setIncrementBy(1)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Compare1_LessThan_wires

    public sub WaypointSensor1_Change_wires()
        ' wire Wire1 is a copy wire
        call Compare1.setInput1(WaypointSensor1.Distance)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire15 is a copy wire
        call Divide1.setInput1(WaypointSensor1.Bearing)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'WaypointSensor1_Change_wires

    public function getChassisName() as string
        getChassisName = "WheelM"
    end function

    public function getDescription() as string
        getDescription = "Created by Black Eagle||Scenario : Rocket Duos||Teammate : RoverSlaughter||This rover will constantly navigate through waypoints.||It has some rocket and mine avoidance.||Its four laser will damage any enemies who get pinged by the sonar.|"
    end function

    public function specifyComponents() as string
        specifyComponents = "WheelM HealthSensor Laser Sonar Steering Laser HealthPack WaypointSensor LongRangeRadar LongRangeRadar MediumEngine Laser Laser Filter Filter Filter Filter RangeTest Variable Compare HealthManager Div"
        specifyComponents = specifyComponents & "ide Add LoopTimer"
    end function
  
    function loadComponents(vehicleID as integer) as boolean
        loadComponents = false
        if not super.loadComponents(vehicleID) then
           exit function
        end if

        compRegistry as VehicleComponents
        compRegistry = sys.getNamedData("VehicleComponents", "VehicleComponents", mSelf)
        if compRegistry <> null then
           call compRegistry.setVehicleName("LaserWorks")
        end if

        modeEvent as DataEvent
        ' magic object shared with mode-switch component(s)
        modeEvent = sys.getNamedData("DataEvent", "ModeChange", mSelf)
        if modeEvent = null then
           call sys.printToLog("Vehicle LaserWorks can't get ModeChange event!")
        else
           modeCatcher as CatchModeChange
           modeCatcher = new CatchModeChange        ' get handler
           modeCatcher.myVehicle = this             ' bind myself
           call modeEvent.register(modeCatcher)     ' then register handler
        end if

        ' initialize HealthSensor1
        HealthSensor1 = sys.getComponent("HealthSensor")
        if HealthSensor1 = null then
           call sys.printToLog("LaserWorks: HealthSensor1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(HealthSensor1, "HealthSensor", "HealthSensor1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(HealthSensor1, -0.0393064, -0.05, 0) then
            call sys.printToLog("LaserWorks: HealthSensor1 not placed")
            exit function
        end if
        call HealthSensor1.setCritical_pct(25)
        call HealthSensor1.setHealthy_pct(75)

        ' initialize Laser2
        Laser2 = sys.getComponent("Laser")
        if Laser2 = null then
           call sys.printToLog("LaserWorks: Laser2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Laser2, "Laser", "Laser2")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(Laser2, 0.0106936, 0.05, 1) then
            call sys.printToLog("LaserWorks: Laser2 not placed")
            exit function
        end if

        ' initialize Sonar1
        Sonar1 = sys.getComponent("Sonar")
        if Sonar1 = null then
           call sys.printToLog("LaserWorks: Sonar1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Sonar1, "Sonar", "Sonar1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(Sonar1, 0.0106936, 0, 1) then
            call sys.printToLog("LaserWorks: Sonar1 not placed")
            exit function
        end if
        call Sonar1.setAngle(0)
        call Sonar1.setMaxRange(10)

        ' initialize Steering1
        Steering1 = sys.getComponent("Steering")
        if Steering1 = null then
           call sys.printToLog("LaserWorks: Steering1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Steering1, "Steering", "Steering1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(Steering1, 0.0106936, -0.05, 0) then
            call sys.printToLog("LaserWorks: Steering1 not placed")
            exit function
        end if
        call Steering1.setAngle(0)

        ' initialize Laser3
        Laser3 = sys.getComponent("Laser")
        if Laser3 = null then
           call sys.printToLog("LaserWorks: Laser3 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Laser3, "Laser", "Laser3")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(Laser3, -0.0393064, 0.05, 1) then
            call sys.printToLog("LaserWorks: Laser3 not placed")
            exit function
        end if

        ' initialize HealthPack1
        HealthPack1 = sys.getComponent("HealthPack")
        if HealthPack1 = null then
           call sys.printToLog("LaserWorks: HealthPack1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(HealthPack1, "HealthPack", "HealthPack1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(HealthPack1, -0.0393064, 0, 0) then
            call sys.printToLog("LaserWorks: HealthPack1 not placed")
            exit function
        end if

        ' initialize WaypointSensor1
        WaypointSensor1 = sys.getComponent("WaypointSensor")
        if WaypointSensor1 = null then
           call sys.printToLog("LaserWorks: WaypointSensor1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(WaypointSensor1, "WaypointSensor", "WaypointSensor1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(WaypointSensor1, -0.134306, 0, 0) then
            call sys.printToLog("LaserWorks: WaypointSensor1 not placed")
            exit function
        end if
        call WaypointSensor1.setCurrentWaypoint(1)
        call WaypointSensor1.setWaypointList("hgfe")

        ' initialize LongRangeRadar1
        LongRangeRadar1 = sys.getComponent("LongRangeRadar")
        if LongRangeRadar1 = null then
           call sys.printToLog("LaserWorks: LongRangeRadar1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(LongRangeRadar1, "LongRangeRadar", "LongRangeRadar1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(LongRangeRadar1, 0.1095, 0.05, 0) then
            call sys.printToLog("LaserWorks: LongRangeRadar1 not placed")
            exit function
        end if
        call LongRangeRadar1.setMaxRange(2)
        call LongRangeRadar1.setAngle(10)
        call LongRangeRadar1.setScanWidth(20)

        ' initialize LongRangeRadar2
        LongRangeRadar2 = sys.getComponent("LongRangeRadar")
        if LongRangeRadar2 = null then
           call sys.printToLog("LaserWorks: LongRangeRadar2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(LongRangeRadar2, "LongRangeRadar", "LongRangeRadar2")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(LongRangeRadar2, 0.1095, -0.05, 0) then
            call sys.printToLog("LaserWorks: LongRangeRadar2 not placed")
            exit function
        end if
        call LongRangeRadar2.setMaxRange(2)
        call LongRangeRadar2.setAngle(-10)
        call LongRangeRadar2.setScanWidth(20)

        ' initialize MediumEngine1
        MediumEngine1 = sys.getComponent("MediumEngine")
        if MediumEngine1 = null then
           call sys.printToLog("LaserWorks: MediumEngine1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(MediumEngine1, "MediumEngine", "MediumEngine1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(MediumEngine1, -0.0143064, -0.1, 0) then
            call sys.printToLog("LaserWorks: MediumEngine1 not placed")
            exit function
        end if
        call MediumEngine1.setThrottle(100)

        ' initialize Laser4
        Laser4 = sys.getComponent("Laser")
        if Laser4 = null then
           call sys.printToLog("LaserWorks: Laser4 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Laser4, "Laser", "Laser4")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(Laser4, 0.0106936, 0.1, 1) then
            call sys.printToLog("LaserWorks: Laser4 not placed")
            exit function
        end if

        ' initialize Laser5
        Laser5 = sys.getComponent("Laser")
        if Laser5 = null then
           call sys.printToLog("LaserWorks: Laser5 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Laser5, "Laser", "Laser5")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(Laser5, -0.0393064, 0.1, 1) then
            call sys.printToLog("LaserWorks: Laser5 not placed")
            exit function
        end if

        ' initialize Filter1
        Filter1 = sys.getComponent("Filter")
        if Filter1 = null then
           call sys.printToLog("LaserWorks: Filter1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Filter1, "Filter", "Filter1")
        end if
        ' Logical component doesn't need to be positioned
        call Filter1.setEnemyVehicle(1)
        call Filter1.setFilterSocket("")
        call Filter1.setOther(0)
        call Filter1.setProjectile(0)
        call Filter1.setTeammate(0)

        ' initialize Filter2
        Filter2 = sys.getComponent("Filter")
        if Filter2 = null then
           call sys.printToLog("LaserWorks: Filter2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Filter2, "Filter", "Filter2")
        end if
        ' Logical component doesn't need to be positioned
        call Filter2.setEnemyVehicle(0)
        call Filter2.setFilterSocket("")
        call Filter2.setOther(0)
        call Filter2.setProjectile(1)
        call Filter2.setTeammate(0)

        ' initialize Filter3
        Filter3 = sys.getComponent("Filter")
        if Filter3 = null then
           call sys.printToLog("LaserWorks: Filter3 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Filter3, "Filter", "Filter3")
        end if
        ' Logical component doesn't need to be positioned
        call Filter3.setEnemyVehicle(0)
        call Filter3.setFilterSocket("")
        call Filter3.setOther(0)
        call Filter3.setProjectile(1)
        call Filter3.setTeammate(0)

        ' initialize Filter4
        Filter4 = sys.getComponent("Filter")
        if Filter4 = null then
           call sys.printToLog("LaserWorks: Filter4 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Filter4, "Filter", "Filter4")
        end if
        ' Logical component doesn't need to be positioned
        call Filter4.setEnemyVehicle(0)
        call Filter4.setFilterSocket("")
        call Filter4.setOther(0)
        call Filter4.setProjectile(1)
        call Filter4.setTeammate(0)

        ' initialize RangeTest1
        RangeTest1 = sys.getComponent("RangeTest")
        if RangeTest1 = null then
           call sys.printToLog("LaserWorks: RangeTest1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(RangeTest1, "RangeTest", "RangeTest1")
        end if
        ' Logical component doesn't need to be positioned
        call RangeTest1.setMaximum(4)
        call RangeTest1.setMinimum(1)
        call RangeTest1.setInput(0)

        ' initialize Variable1
        Variable1 = sys.getComponent("Variable")
        if Variable1 = null then
           call sys.printToLog("LaserWorks: Variable1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Variable1, "Variable", "Variable1")
        end if
        ' Logical component doesn't need to be positioned
        call Variable1.setInput(1)

        ' initialize Compare1
        Compare1 = sys.getComponent("Compare")
        if Compare1 = null then
           call sys.printToLog("LaserWorks: Compare1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Compare1, "Compare", "Compare1")
        end if
        ' Logical component doesn't need to be positioned
        call Compare1.setInput1(0)
        call Compare1.setInput2(2)
        call Compare1.setCalc(1)

        ' initialize HealthManager1
        HealthManager1 = sys.getComponent("HealthManager")
        if HealthManager1 = null then
           call sys.printToLog("LaserWorks: HealthManager1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(HealthManager1, "HealthManager", "HealthManager1")
        end if
        ' Logical component doesn't need to be positioned
        call HealthManager1.setHealth(100)

        ' initialize Divide1
        Divide1 = sys.getComponent("Divide")
        if Divide1 = null then
           call sys.printToLog("LaserWorks: Divide1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Divide1, "Divide", "Divide1")
        end if
        ' Logical component doesn't need to be positioned
        call Divide1.setInput1(0)
        call Divide1.setInput2(3)
        call Divide1.setCalc(1)

        ' initialize Add1
        Add1 = sys.getComponent("Add")
        if Add1 = null then
           call sys.printToLog("LaserWorks: Add1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Add1, "Add", "Add1")
        end if
        ' Logical component doesn't need to be positioned
        call Add1.setInput1(0)
        call Add1.setInput2(0)

        ' initialize LoopTimer1
        LoopTimer1 = sys.getComponent("LoopTimer")
        if LoopTimer1 = null then
           call sys.printToLog("LaserWorks: LoopTimer1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(LoopTimer1, "LoopTimer", "LoopTimer1")
        end if
        ' Logical component doesn't need to be positioned
        call LoopTimer1.setTickTime(0.1)

        call Filter4.TurnOff.register(Filter4_TurnOff_wires)
        call Filter3.TurnOff.register(Filter3_TurnOff_wires)
        call LoopTimer1.Tick.register(LoopTimer1_Tick_wires)
        call Filter4.TurnOn.register(Filter4_TurnOn_wires)
        call Filter3.TurnOn.register(Filter3_TurnOn_wires)
        call LongRangeRadar2.PlugIn.register(LongRangeRadar2_PlugIn_wires)
        call LongRangeRadar1.PlugIn.register(LongRangeRadar1_PlugIn_wires)
        call Divide1.Change.register(Divide1_Change_wires)
        call Add1.Change.register(Add1_Change_wires)
        call HealthManager1.UseHP1.register(HealthManager1_UseHP1_wires)
        call HealthSensor1.Change.register(HealthSensor1_Change_wires)
        call Filter2.TurnOn.register(Filter2_TurnOn_wires)
        call Filter1.TurnOn.register(Filter1_TurnOn_wires)
        call Sonar1.PlugIn.register(Sonar1_PlugIn_wires)
        call RangeTest1.AboveRange.register(RangeTest1_AboveRange_wires)
        call Variable1.Change.register(Variable1_Change_wires)
        call Compare1.LessThan.register(Compare1_LessThan_wires)
        call WaypointSensor1.Change.register(WaypointSensor1_Change_wires)

  ' *** place user initialization here ***
  ' *** end of user initialization ***

        loadComponents = true           ' if we got this far, we succeeded
    end function 'loadComponents

    sub init(sysobj as VehicleSystemObject)
        sys = sysobj
  ' *** place user variable init here ***
  ' *** end of user variable init ***
    end sub 'init

end class 'LaserWorks
' END TEMPLATE
