' TEMPLATE

' NOTE: This file is generated automatically. Do not make modifications
' outside the designated areas; if you do, your changes may be lost.


' private helper class
class CatchModeChange extends DataEventHandler
  myVehicle as Vehicle

  sub handle(name as string, data as EventData)
    call myVehicle.setWireColor(data.getInt())
  end sub 'handle
end class 'CatchModeChange

  ' *** place user const declarations here ***
  ' *** end of user const declarations ***

class RoundAndRound extends Vehicle
    sys as VehicleSystemObject
    
    Steering1 as Steering
    HealthPack2 as HealthPack
    HealthPack3 as HealthPack
    Laser1 as Laser
    LongRangeRadar2 as LongRangeRadar
    MediumEngine1 as MediumEngine
    LongRangeRadar3 as LongRangeRadar
    Sonar1 as Sonar
    BattleLaser1 as BattleLaser
    BattleLaser2 as BattleLaser
    BattleLaser3 as BattleLaser
    BumpSensor1 as BumpSensor
    HealthSensor1 as HealthSensor
    Filter3 as Filter
    HealthManager1 as HealthManager
    Filter2 as Filter
    LogicalAND1 as LogicalAND
    LogicalNOT1 as LogicalNOT
    LogicalNOT2 as LogicalNOT
    LogicalAND2 as LogicalAND
    LogicalNOR1 as LogicalNOR
    Timer1 as Timer
    ModeSwitch1 as ModeSwitch
    Startup1 as Startup
    LogicalOR1 as LogicalOR
    LoopTimer2 as LoopTimer
    Filter1 as Filter
    Filter4 as Filter

  ' *** place vehicle data and subs here ***
  ' *** end of vehicle data and subs ***

    public function getGroup() as string
        getGroup = "Battle"
    end function 'getGroup

    public function getVer() as float
        getVer = 1.01
    end function 'getVer

    public sub Filter4_TurnOn_wires()
        ' wire Wire8 is sendto wire
        call Laser1.Fire()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Filter4_TurnOn_wires

    public sub Filter1_TurnOn_wires()
        ' wire Wire3 is sendto wire
        call BattleLaser3.Fire()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire4 is sendto wire
        call BattleLaser2.Fire()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire5 is sendto wire
        call BattleLaser1.Fire()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire6 is sendto wire
        call Laser1.Fire()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Filter1_TurnOn_wires

    public sub Sonar1_PlugIn_wires()
        ' wire Wire17 is a copy wire
        call Filter1.setFilterSocket(Sonar1.FilterPlug)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire7 is a copy wire
        call Filter4.setFilterSocket(Sonar1.FilterPlug)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Sonar1_PlugIn_wires

    public sub LoopTimer2_Tick_wires()
        ' wire Wire10 is sendto wire
        call Sonar1.Fire()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'LoopTimer2_Tick_wires

    public sub LongRangeRadar3_PlugIn_wires()
        ' wire Wire21 is a copy wire
        call Filter2.setFilterSocket(LongRangeRadar3.FilterPlug)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'LongRangeRadar3_PlugIn_wires

    public sub ModeSwitch1_Change_wires()
        select case mWireColor
        case 1
            ' wire Wire50 is sendto wire
            call MediumEngine1.setThrottle(100)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        case 2
            ' wire Wire49 is sendto wire
            call MediumEngine1.setThrottle(-100)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        end select
    end sub 'ModeSwitch1_Change_wires

    public sub Startup1_Tick_wires()
        ' wire Wire48 is sendto wire
        call ModeSwitch1.setMode(1)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Startup1_Tick_wires

    public sub Timer1_Tick_wires()
        ' wire Wire47 is sendto wire
        call Steering1.setAngle(30)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire46 is sendto wire
        call MediumEngine1.setThrottle(100)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Timer1_Tick_wires

    public sub BumpSensor1_Bump_wires()
        select case mWireColor
        case 1
            ' wire Wire40 is sendto wire
            call ModeSwitch1.setMode(2)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        case 2
            ' wire Wire51 is sendto wire
            call ModeSwitch1.setMode(1)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        end select
        ' wire Wire44 is sendto wire
        call Steering1.setAngle(0)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire45 is sendto wire
        call Timer1.setTickTime(2)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'BumpSensor1_Bump_wires

    public sub LogicalNOR1_TurnOn_wires()
        ' wire Wire32 is sendto wire
        call Steering1.setAngle(20)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'LogicalNOR1_TurnOn_wires

    public sub LogicalAND2_TurnOn_wires()
        ' wire Wire29 is sendto wire
        call Steering1.setAngle(30)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'LogicalAND2_TurnOn_wires

    public sub LogicalNOT2_Change_wires()
        ' wire Wire28 is a copy wire
        call LogicalAND2.setInputB(LogicalNOT2.State)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'LogicalNOT2_Change_wires

    public sub LogicalAND1_TurnOn_wires()
        ' wire Wire25 is sendto wire
        call Steering1.setAngle(-10)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'LogicalAND1_TurnOn_wires

    public sub LogicalNOT1_Change_wires()
        ' wire Wire24 is a copy wire
        call LogicalAND1.setInputB(LogicalNOT1.State)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'LogicalNOT1_Change_wires

    public sub Filter2_Change_wires()
        ' wire Wire23 is a copy wire
        call LogicalAND1.setInputA(Filter2.State)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire26 is a copy wire
        call LogicalNOT2.setInputA(Filter2.State)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire30 is a copy wire
        call LogicalNOR1.setInputA(Filter2.State)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire1 is a copy wire
        call LogicalOR1.setInputA(Filter2.State)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Filter2_Change_wires

    public sub Filter3_Change_wires()
        ' wire Wire22 is a copy wire
        call LogicalNOT1.setInputA(Filter3.State)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire27 is a copy wire
        call LogicalAND2.setInputA(Filter3.State)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire31 is a copy wire
        call LogicalNOR1.setInputB(Filter3.State)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire2 is a copy wire
        call LogicalOR1.setInputB(Filter3.State)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Filter3_Change_wires

    public sub HealthManager1_UseHP2_wires()
        ' wire Wire16 is sendto wire
        call HealthPack2.Trigger()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'HealthManager1_UseHP2_wires

    public sub HealthManager1_UseHP1_wires()
        ' wire Wire15 is sendto wire
        call HealthPack3.Trigger()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'HealthManager1_UseHP1_wires

    public sub HealthSensor1_Change_wires()
        ' wire Wire14 is a copy wire
        call HealthManager1.setHealth(HealthSensor1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'HealthSensor1_Change_wires

    public sub LongRangeRadar2_PlugIn_wires()
        ' wire Wire11 is a copy wire
        call Filter3.setFilterSocket(LongRangeRadar2.FilterPlug)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'LongRangeRadar2_PlugIn_wires

    public function getChassisName() as string
        getChassisName = "WheelL"
    end function

    public function getDescription() as string
        getDescription = "Created by Black Eagle||Scenario : Rocket Duos||Teammate : WaitAndWait||Will try to circle enemies and whittle their health with 3 Battle Lasers and one laser.||Sometimes get stuck, but not too often.|"
    end function

    public function specifyComponents() as string
        specifyComponents = "WheelL Steering HealthPack HealthPack Laser LongRangeRadar MediumEngine LongRangeRadar Sonar BattleLaser BattleLaser BattleLaser BumpSensor HealthSensor Filter HealthManager Filter LogicalAND LogicalN"
        specifyComponents = specifyComponents & "OT LogicalNOT LogicalAND LogicalNOR Timer ModeSwitch Startup LogicalOR LoopTimer Filter Filter"
    end function
  
    function loadComponents(vehicleID as integer) as boolean
        loadComponents = false
        if not super.loadComponents(vehicleID) then
           exit function
        end if

        compRegistry as VehicleComponents
        compRegistry = sys.getNamedData("VehicleComponents", "VehicleComponents", mSelf)
        if compRegistry <> null then
           call compRegistry.setVehicleName("RoundAndRound")
        end if

        modeEvent as DataEvent
        ' magic object shared with mode-switch component(s)
        modeEvent = sys.getNamedData("DataEvent", "ModeChange", mSelf)
        if modeEvent = null then
           call sys.printToLog("Vehicle RoundAndRound can't get ModeChange event!")
        else
           modeCatcher as CatchModeChange
           modeCatcher = new CatchModeChange        ' get handler
           modeCatcher.myVehicle = this             ' bind myself
           call modeEvent.register(modeCatcher)     ' then register handler
        end if

        ' initialize Steering1
        Steering1 = sys.getComponent("Steering")
        if Steering1 = null then
           call sys.printToLog("RoundAndRound: Steering1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Steering1, "Steering", "Steering1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(Steering1, -0.109, -0.125, 0) then
            call sys.printToLog("RoundAndRound: Steering1 not placed")
            exit function
        end if
        call Steering1.setAngle(30)

        ' initialize HealthPack2
        HealthPack2 = sys.getComponent("HealthPack")
        if HealthPack2 = null then
           call sys.printToLog("RoundAndRound: HealthPack2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(HealthPack2, "HealthPack", "HealthPack2")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(HealthPack2, -0.059, 0.125, 0) then
            call sys.printToLog("RoundAndRound: HealthPack2 not placed")
            exit function
        end if

        ' initialize HealthPack3
        HealthPack3 = sys.getComponent("HealthPack")
        if HealthPack3 = null then
           call sys.printToLog("RoundAndRound: HealthPack3 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(HealthPack3, "HealthPack", "HealthPack3")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(HealthPack3, -0.109, 0.125, 0) then
            call sys.printToLog("RoundAndRound: HealthPack3 not placed")
            exit function
        end if

        ' initialize Laser1
        Laser1 = sys.getComponent("Laser")
        if Laser1 = null then
           call sys.printToLog("RoundAndRound: Laser1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Laser1, "Laser", "Laser1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(Laser1, -0.009, -0.125, 1) then
            call sys.printToLog("RoundAndRound: Laser1 not placed")
            exit function
        end if

        ' initialize LongRangeRadar2
        LongRangeRadar2 = sys.getComponent("LongRangeRadar")
        if LongRangeRadar2 = null then
           call sys.printToLog("RoundAndRound: LongRangeRadar2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(LongRangeRadar2, "LongRangeRadar", "LongRangeRadar2")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(LongRangeRadar2, -0.046, 0.05, 1) then
            call sys.printToLog("RoundAndRound: LongRangeRadar2 not placed")
            exit function
        end if
        call LongRangeRadar2.setMaxRange(10)
        call LongRangeRadar2.setAngle(15)
        call LongRangeRadar2.setScanWidth(30)

        ' initialize MediumEngine1
        MediumEngine1 = sys.getComponent("MediumEngine")
        if MediumEngine1 = null then
           call sys.printToLog("RoundAndRound: MediumEngine1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(MediumEngine1, "MediumEngine", "MediumEngine1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(MediumEngine1, -0.096, -0.025, 1) then
            call sys.printToLog("RoundAndRound: MediumEngine1 not placed")
            exit function
        end if
        call MediumEngine1.setThrottle(100)

        ' initialize LongRangeRadar3
        LongRangeRadar3 = sys.getComponent("LongRangeRadar")
        if LongRangeRadar3 = null then
           call sys.printToLog("RoundAndRound: LongRangeRadar3 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(LongRangeRadar3, "LongRangeRadar", "LongRangeRadar3")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(LongRangeRadar3, 0.054, 0.05, 1) then
            call sys.printToLog("RoundAndRound: LongRangeRadar3 not placed")
            exit function
        end if
        call LongRangeRadar3.setMaxRange(10)
        call LongRangeRadar3.setAngle(-15)
        call LongRangeRadar3.setScanWidth(30)

        ' initialize Sonar1
        Sonar1 = sys.getComponent("Sonar")
        if Sonar1 = null then
           call sys.printToLog("RoundAndRound: Sonar1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Sonar1, "Sonar", "Sonar1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(Sonar1, 0.004, 0.05, 1) then
            call sys.printToLog("RoundAndRound: Sonar1 not placed")
            exit function
        end if
        call Sonar1.setAngle(0)
        call Sonar1.setMaxRange(10)

        ' initialize BattleLaser1
        BattleLaser1 = sys.getComponent("BattleLaser")
        if BattleLaser1 = null then
           call sys.printToLog("RoundAndRound: BattleLaser1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(BattleLaser1, "BattleLaser", "BattleLaser1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(BattleLaser1, 0.054, -0.025, 1) then
            call sys.printToLog("RoundAndRound: BattleLaser1 not placed")
            exit function
        end if
        call BattleLaser1.setAngle(0)
        call BattleLaser1.setPower(2)

        ' initialize BattleLaser2
        BattleLaser2 = sys.getComponent("BattleLaser")
        if BattleLaser2 = null then
           call sys.printToLog("RoundAndRound: BattleLaser2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(BattleLaser2, "BattleLaser", "BattleLaser2")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(BattleLaser2, 0.004, -0.025, 1) then
            call sys.printToLog("RoundAndRound: BattleLaser2 not placed")
            exit function
        end if
        call BattleLaser2.setAngle(0)
        call BattleLaser2.setPower(2)

        ' initialize BattleLaser3
        BattleLaser3 = sys.getComponent("BattleLaser")
        if BattleLaser3 = null then
           call sys.printToLog("RoundAndRound: BattleLaser3 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(BattleLaser3, "BattleLaser", "BattleLaser3")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(BattleLaser3, -0.046, -0.025, 1) then
            call sys.printToLog("RoundAndRound: BattleLaser3 not placed")
            exit function
        end if
        call BattleLaser3.setAngle(0)
        call BattleLaser3.setPower(2)

        ' initialize BumpSensor1
        BumpSensor1 = sys.getComponent("BumpSensor")
        if BumpSensor1 = null then
           call sys.printToLog("RoundAndRound: BumpSensor1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(BumpSensor1, "BumpSensor", "BumpSensor1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(BumpSensor1, 0.176, 0.11, 0) then
            call sys.printToLog("RoundAndRound: BumpSensor1 not placed")
            exit function
        end if

        ' initialize HealthSensor1
        HealthSensor1 = sys.getComponent("HealthSensor")
        if HealthSensor1 = null then
           call sys.printToLog("RoundAndRound: HealthSensor1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(HealthSensor1, "HealthSensor", "HealthSensor1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(HealthSensor1, 0.176, -0.11, 0) then
            call sys.printToLog("RoundAndRound: HealthSensor1 not placed")
            exit function
        end if
        call HealthSensor1.setCritical_pct(25)
        call HealthSensor1.setHealthy_pct(75)

        ' initialize Filter3
        Filter3 = sys.getComponent("Filter")
        if Filter3 = null then
           call sys.printToLog("RoundAndRound: Filter3 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Filter3, "Filter", "Filter3")
        end if
        ' Logical component doesn't need to be positioned
        call Filter3.setEnemyVehicle(1)
        call Filter3.setFilterSocket("")
        call Filter3.setOther(0)
        call Filter3.setProjectile(0)
        call Filter3.setTeammate(0)

        ' initialize HealthManager1
        HealthManager1 = sys.getComponent("HealthManager")
        if HealthManager1 = null then
           call sys.printToLog("RoundAndRound: HealthManager1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(HealthManager1, "HealthManager", "HealthManager1")
        end if
        ' Logical component doesn't need to be positioned
        call HealthManager1.setHealth(100)

        ' initialize Filter2
        Filter2 = sys.getComponent("Filter")
        if Filter2 = null then
           call sys.printToLog("RoundAndRound: Filter2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Filter2, "Filter", "Filter2")
        end if
        ' Logical component doesn't need to be positioned
        call Filter2.setEnemyVehicle(1)
        call Filter2.setFilterSocket("")
        call Filter2.setOther(0)
        call Filter2.setProjectile(0)
        call Filter2.setTeammate(0)

        ' initialize LogicalAND1
        LogicalAND1 = sys.getComponent("LogicalAND")
        if LogicalAND1 = null then
           call sys.printToLog("RoundAndRound: LogicalAND1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(LogicalAND1, "LogicalAND", "LogicalAND1")
        end if
        ' Logical component doesn't need to be positioned
        call LogicalAND1.setInputA(0)
        call LogicalAND1.setInputB(0)

        ' initialize LogicalNOT1
        LogicalNOT1 = sys.getComponent("LogicalNOT")
        if LogicalNOT1 = null then
           call sys.printToLog("RoundAndRound: LogicalNOT1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(LogicalNOT1, "LogicalNOT", "LogicalNOT1")
        end if
        ' Logical component doesn't need to be positioned
        call LogicalNOT1.setInputA(1)

        ' initialize LogicalNOT2
        LogicalNOT2 = sys.getComponent("LogicalNOT")
        if LogicalNOT2 = null then
           call sys.printToLog("RoundAndRound: LogicalNOT2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(LogicalNOT2, "LogicalNOT", "LogicalNOT2")
        end if
        ' Logical component doesn't need to be positioned
        call LogicalNOT2.setInputA(1)

        ' initialize LogicalAND2
        LogicalAND2 = sys.getComponent("LogicalAND")
        if LogicalAND2 = null then
           call sys.printToLog("RoundAndRound: LogicalAND2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(LogicalAND2, "LogicalAND", "LogicalAND2")
        end if
        ' Logical component doesn't need to be positioned
        call LogicalAND2.setInputA(0)
        call LogicalAND2.setInputB(0)

        ' initialize LogicalNOR1
        LogicalNOR1 = sys.getComponent("LogicalNOR")
        if LogicalNOR1 = null then
           call sys.printToLog("RoundAndRound: LogicalNOR1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(LogicalNOR1, "LogicalNOR", "LogicalNOR1")
        end if
        ' Logical component doesn't need to be positioned
        call LogicalNOR1.setInputA(0)
        call LogicalNOR1.setInputB(0)

        ' initialize Timer1
        Timer1 = sys.getComponent("Timer")
        if Timer1 = null then
           call sys.printToLog("RoundAndRound: Timer1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Timer1, "Timer", "Timer1")
        end if
        ' Logical component doesn't need to be positioned
        call Timer1.setTickTime(0)

        ' initialize ModeSwitch1
        ModeSwitch1 = sys.getComponent("ModeSwitch")
        if ModeSwitch1 = null then
           call sys.printToLog("RoundAndRound: ModeSwitch1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(ModeSwitch1, "ModeSwitch", "ModeSwitch1")
        end if
        ' Logical component doesn't need to be positioned
        call ModeSwitch1.setMode(0)

        ' initialize Startup1
        Startup1 = sys.getComponent("Startup")
        if Startup1 = null then
           call sys.printToLog("RoundAndRound: Startup1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Startup1, "Startup", "Startup1")
        end if
        ' Logical component doesn't need to be positioned

        ' initialize LogicalOR1
        LogicalOR1 = sys.getComponent("LogicalOR")
        if LogicalOR1 = null then
           call sys.printToLog("RoundAndRound: LogicalOR1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(LogicalOR1, "LogicalOR", "LogicalOR1")
        end if
        ' Logical component doesn't need to be positioned
        call LogicalOR1.setInputA(0)
        call LogicalOR1.setInputB(0)

        ' initialize LoopTimer2
        LoopTimer2 = sys.getComponent("LoopTimer")
        if LoopTimer2 = null then
           call sys.printToLog("RoundAndRound: LoopTimer2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(LoopTimer2, "LoopTimer", "LoopTimer2")
        end if
        ' Logical component doesn't need to be positioned
        call LoopTimer2.setTickTime(0.1)

        ' initialize Filter1
        Filter1 = sys.getComponent("Filter")
        if Filter1 = null then
           call sys.printToLog("RoundAndRound: Filter1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Filter1, "Filter", "Filter1")
        end if
        ' Logical component doesn't need to be positioned
        call Filter1.setEnemyVehicle(1)
        call Filter1.setFilterSocket("")
        call Filter1.setOther(0)
        call Filter1.setProjectile(0)
        call Filter1.setTeammate(0)

        ' initialize Filter4
        Filter4 = sys.getComponent("Filter")
        if Filter4 = null then
           call sys.printToLog("RoundAndRound: Filter4 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Filter4, "Filter", "Filter4")
        end if
        ' Logical component doesn't need to be positioned
        call Filter4.setEnemyVehicle(0)
        call Filter4.setFilterSocket("")
        call Filter4.setOther(0)
        call Filter4.setProjectile(1)
        call Filter4.setTeammate(0)

        call Filter4.TurnOn.register(Filter4_TurnOn_wires)
        call Filter1.TurnOn.register(Filter1_TurnOn_wires)
        call Sonar1.PlugIn.register(Sonar1_PlugIn_wires)
        call LoopTimer2.Tick.register(LoopTimer2_Tick_wires)
        call LongRangeRadar3.PlugIn.register(LongRangeRadar3_PlugIn_wires)
        call ModeSwitch1.Change.register(ModeSwitch1_Change_wires)
        call Startup1.Tick.register(Startup1_Tick_wires)
        call Timer1.Tick.register(Timer1_Tick_wires)
        call BumpSensor1.Bump.register(BumpSensor1_Bump_wires)
        call LogicalNOR1.TurnOn.register(LogicalNOR1_TurnOn_wires)
        call LogicalAND2.TurnOn.register(LogicalAND2_TurnOn_wires)
        call LogicalNOT2.Change.register(LogicalNOT2_Change_wires)
        call LogicalAND1.TurnOn.register(LogicalAND1_TurnOn_wires)
        call LogicalNOT1.Change.register(LogicalNOT1_Change_wires)
        call Filter2.Change.register(Filter2_Change_wires)
        call Filter3.Change.register(Filter3_Change_wires)
        call HealthManager1.UseHP2.register(HealthManager1_UseHP2_wires)
        call HealthManager1.UseHP1.register(HealthManager1_UseHP1_wires)
        call HealthSensor1.Change.register(HealthSensor1_Change_wires)
        call LongRangeRadar2.PlugIn.register(LongRangeRadar2_PlugIn_wires)

  ' *** place user initialization here ***
  ' *** end of user initialization ***

        loadComponents = true           ' if we got this far, we succeeded
    end function 'loadComponents

    sub init(sysobj as VehicleSystemObject)
        sys = sysobj
  ' *** place user variable init here ***
  ' *** end of user variable init ***
    end sub 'init

end class 'RoundAndRound
' END TEMPLATE
