' TEMPLATE

' NOTE: This file is generated automatically. Do not make modifications
' outside the designated areas; if you do, your changes may be lost.


' private helper class
class CatchModeChange extends DataEventHandler
  myVehicle as Vehicle

  sub handle(name as string, data as EventData)
    call myVehicle.setWireColor(data.getInt())
  end sub 'handle
end class 'CatchModeChange

  ' *** place user const declarations here ***
  ' *** end of user const declarations ***

class SeedMouse extends Vehicle
    sys as VehicleSystemObject
    
    SmallEngine1 as SmallEngine
    Steering1 as Steering
    Sonar1 as Sonar
    WaypointSensor1 as WaypointSensor
    RocketLauncher1 as RocketLauncher
    Filter1 as Filter
    Compare1 as Compare
    RangeTest1 as RangeTest
    Variable1 as Variable
    Divide1 as Divide
    LoopTimer1 as LoopTimer

  ' *** place vehicle data and subs here ***
  ' *** end of vehicle data and subs ***

    public function getGroup() as string
        getGroup = "Battle"
    end function 'getGroup

    public function getVer() as float
        getVer = 1.01
    end function 'getVer

    public sub Filter1_TurnOn_wires()
        ' wire Wire9 is sendto wire
        call RocketLauncher1.Fire()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Filter1_TurnOn_wires

    public sub Sonar1_PlugIn_wires()
        ' wire Wire8 is a copy wire
        call Filter1.setFilterSocket(Sonar1.FilterPlug)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Sonar1_PlugIn_wires

    public sub LoopTimer1_Tick_wires()
        ' wire Wire7 is sendto wire
        call Sonar1.Fire()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'LoopTimer1_Tick_wires

    public sub Divide1_Change_wires()
        ' wire Wire6 is a copy wire
        call Steering1.setAngle(Divide1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Divide1_Change_wires

    public sub RangeTest1_AboveRange_wires()
        ' wire Wire4 is a copy wire
        call Variable1.setInput(RangeTest1.Minimum)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'RangeTest1_AboveRange_wires

    public sub Variable1_Change_wires()
        ' wire Wire3 is a copy wire
        call WaypointSensor1.setCurrentWaypoint(Variable1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Variable1_Change_wires

    public sub Compare1_LessThan_wires()
        ' wire Wire2 is sendto wire
        call Variable1.setIncrementBy(1)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Compare1_LessThan_wires

    public sub WaypointSensor1_Change_wires()
        ' wire Wire1 is a copy wire
        call Compare1.setInput1(WaypointSensor1.Distance)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire5 is a copy wire
        call Divide1.setInput1(WaypointSensor1.Bearing)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'WaypointSensor1_Change_wires

    public function getChassisName() as string
        getChassisName = "MouseChassisB"
    end function

    public function getDescription() as string
        getDescription = "Created by Black Eagle||Scenario : Rocket Duos||Teammate : SeedPuck||This two rovers is underpowered. They only uses 295 Points and 905 Weight.||Beating this team should be a very easy job.||This mouse will navigate using waypoints to circle the arena.|"
    end function

    public function specifyComponents() as string
        specifyComponents = "MouseChassisB SmallEngine Steering Sonar WaypointSensor RocketLauncher Filter Compare RangeTest Variable Divide LoopTimer"
    end function
  
    function loadComponents(vehicleID as integer) as boolean
        loadComponents = false
        if not super.loadComponents(vehicleID) then
           exit function
        end if

        compRegistry as VehicleComponents
        compRegistry = sys.getNamedData("VehicleComponents", "VehicleComponents", mSelf)
        if compRegistry <> null then
           call compRegistry.setVehicleName("SeedMouse")
        end if

        modeEvent as DataEvent
        ' magic object shared with mode-switch component(s)
        modeEvent = sys.getNamedData("DataEvent", "ModeChange", mSelf)
        if modeEvent = null then
           call sys.printToLog("Vehicle SeedMouse can't get ModeChange event!")
        else
           modeCatcher as CatchModeChange
           modeCatcher = new CatchModeChange        ' get handler
           modeCatcher.myVehicle = this             ' bind myself
           call modeEvent.register(modeCatcher)     ' then register handler
        end if

        ' initialize SmallEngine1
        SmallEngine1 = sys.getComponent("SmallEngine")
        if SmallEngine1 = null then
           call sys.printToLog("SeedMouse: SmallEngine1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(SmallEngine1, "SmallEngine", "SmallEngine1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(SmallEngine1, -0.045, -0.05, 0) then
            call sys.printToLog("SeedMouse: SmallEngine1 not placed")
            exit function
        end if
        call SmallEngine1.setThrottle(100)

        ' initialize Steering1
        Steering1 = sys.getComponent("Steering")
        if Steering1 = null then
           call sys.printToLog("SeedMouse: Steering1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Steering1, "Steering", "Steering1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(Steering1, 0.005, -0.05, 0) then
            call sys.printToLog("SeedMouse: Steering1 not placed")
            exit function
        end if
        call Steering1.setAngle(0)

        ' initialize Sonar1
        Sonar1 = sys.getComponent("Sonar")
        if Sonar1 = null then
           call sys.printToLog("SeedMouse: Sonar1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Sonar1, "Sonar", "Sonar1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(Sonar1, 0.005, 0.05, 1) then
            call sys.printToLog("SeedMouse: Sonar1 not placed")
            exit function
        end if
        call Sonar1.setAngle(0)
        call Sonar1.setMaxRange(15)

        ' initialize WaypointSensor1
        WaypointSensor1 = sys.getComponent("WaypointSensor")
        if WaypointSensor1 = null then
           call sys.printToLog("SeedMouse: WaypointSensor1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(WaypointSensor1, "WaypointSensor", "WaypointSensor1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(WaypointSensor1, 0.005, 0, 0) then
            call sys.printToLog("SeedMouse: WaypointSensor1 not placed")
            exit function
        end if
        call WaypointSensor1.setCurrentWaypoint(1)
        call WaypointSensor1.setWaypointList("ehgfk")

        ' initialize RocketLauncher1
        RocketLauncher1 = sys.getComponent("RocketLauncher")
        if RocketLauncher1 = null then
           call sys.printToLog("SeedMouse: RocketLauncher1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(RocketLauncher1, "RocketLauncher", "RocketLauncher1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(RocketLauncher1, -0.045, 0.025, 1) then
            call sys.printToLog("SeedMouse: RocketLauncher1 not placed")
            exit function
        end if
        call RocketLauncher1.setRocketSpeed(1)

        ' initialize Filter1
        Filter1 = sys.getComponent("Filter")
        if Filter1 = null then
           call sys.printToLog("SeedMouse: Filter1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Filter1, "Filter", "Filter1")
        end if
        ' Logical component doesn't need to be positioned
        call Filter1.setEnemyVehicle(1)
        call Filter1.setFilterSocket("")
        call Filter1.setOther(0)
        call Filter1.setProjectile(0)
        call Filter1.setTeammate(0)

        ' initialize Compare1
        Compare1 = sys.getComponent("Compare")
        if Compare1 = null then
           call sys.printToLog("SeedMouse: Compare1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Compare1, "Compare", "Compare1")
        end if
        ' Logical component doesn't need to be positioned
        call Compare1.setInput1(0)
        call Compare1.setInput2(3)
        call Compare1.setCalc(1)

        ' initialize RangeTest1
        RangeTest1 = sys.getComponent("RangeTest")
        if RangeTest1 = null then
           call sys.printToLog("SeedMouse: RangeTest1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(RangeTest1, "RangeTest", "RangeTest1")
        end if
        ' Logical component doesn't need to be positioned
        call RangeTest1.setMaximum(5)
        call RangeTest1.setMinimum(1)
        call RangeTest1.setInput(0)

        ' initialize Variable1
        Variable1 = sys.getComponent("Variable")
        if Variable1 = null then
           call sys.printToLog("SeedMouse: Variable1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Variable1, "Variable", "Variable1")
        end if
        ' Logical component doesn't need to be positioned
        call Variable1.setInput(1)

        ' initialize Divide1
        Divide1 = sys.getComponent("Divide")
        if Divide1 = null then
           call sys.printToLog("SeedMouse: Divide1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Divide1, "Divide", "Divide1")
        end if
        ' Logical component doesn't need to be positioned
        call Divide1.setInput1(0)
        call Divide1.setInput2(8)
        call Divide1.setCalc(1)

        ' initialize LoopTimer1
        LoopTimer1 = sys.getComponent("LoopTimer")
        if LoopTimer1 = null then
           call sys.printToLog("SeedMouse: LoopTimer1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(LoopTimer1, "LoopTimer", "LoopTimer1")
        end if
        ' Logical component doesn't need to be positioned
        call LoopTimer1.setTickTime(0.1)

        call Filter1.TurnOn.register(Filter1_TurnOn_wires)
        call Sonar1.PlugIn.register(Sonar1_PlugIn_wires)
        call LoopTimer1.Tick.register(LoopTimer1_Tick_wires)
        call Divide1.Change.register(Divide1_Change_wires)
        call RangeTest1.AboveRange.register(RangeTest1_AboveRange_wires)
        call Variable1.Change.register(Variable1_Change_wires)
        call Compare1.LessThan.register(Compare1_LessThan_wires)
        call WaypointSensor1.Change.register(WaypointSensor1_Change_wires)

  ' *** place user initialization here ***
  ' *** end of user initialization ***

        loadComponents = true           ' if we got this far, we succeeded
    end function 'loadComponents

    sub init(sysobj as VehicleSystemObject)
        sys = sysobj
  ' *** place user variable init here ***
  ' *** end of user variable init ***
    end sub 'init

end class 'SeedMouse
' END TEMPLATE
