' TEMPLATE

' NOTE: This file is generated automatically. Do not make modifications
' outside the designated areas; if you do, your changes may be lost.


' private helper class
class CatchModeChange extends DataEventHandler
  myVehicle as Vehicle

  sub handle(name as string, data as EventData)
    call myVehicle.setWireColor(data.getInt())
  end sub 'handle
end class 'CatchModeChange

  ' *** place user const declarations here ***
  ' *** end of user const declarations ***

class HoverHumvee extends Vehicle
    sys as VehicleSystemObject
    
    MachineGun1 as MachineGun
    MachineGun2 as MachineGun
    MachineGun3 as MachineGun
    LongRangeRadar1 as LongRangeRadar
    LongRangeRadar2 as LongRangeRadar
    Sonar1 as Sonar
    Thruster1 as Thruster
    Thruster2 as Thruster
    HealthPack1 as HealthPack
    HealthSensor1 as HealthSensor
    XYFinder1 as XYFinder
    HealthPack2 as HealthPack
    HealthManager1 as HealthManager
    LogicalReceiver1 as LogicalReceiver
    LogicalReceiver2 as LogicalReceiver
    ModeSwitch1 as ModeSwitch
    Startup1 as Startup
    Timer1 as Timer
    Timer2 as Timer
    TrakJack1 as TrakJack
    Compare1 as Compare
    Compare2 as Compare
    Divide1 as Divide
    Add1 as Add
    LoopTimer1 as LoopTimer
    Filter1 as Filter
    Filter2 as Filter
    Filter3 as Filter
    LogicalAND1 as LogicalAND
    Add2 as Add
    Subtract1 as Subtract
    Variable1 as Variable
    LogicalAND2 as LogicalAND
    LogicalNOT1 as LogicalNOT
    LogicalAND3 as LogicalAND
    LogicalNOT2 as LogicalNOT
    LogicalNOR1 as LogicalNOR
    pump1 as pump
    pump2 as pump
    RangeTest1 as RangeTest

  ' *** place vehicle data and subs here ***
  ' *** end of vehicle data and subs ***

    public function getGroup() as string
        getGroup = "Battle"
    end function 'getGroup

    public function getVer() as float
        getVer = 1.01
    end function 'getVer

    public sub LogicalAND3_TurnOn_wires()
        ' wire Wire58 is sendto wire
        call Add1.setInput2(180)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'LogicalAND3_TurnOn_wires

    public sub LogicalAND2_TurnOn_wires()
        ' wire Wire57 is sendto wire
        call Add1.setInput2(-180)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'LogicalAND2_TurnOn_wires

    public sub RangeTest1_BelowRange_wires()
        ' wire Wire56 is a copy wire
        call Variable1.setInput(RangeTest1.Minimum)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'RangeTest1_BelowRange_wires

    public sub RangeTest1_AboveRange_wires()
        ' wire Wire55 is a copy wire
        call Variable1.setInput(RangeTest1.Maximum)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'RangeTest1_AboveRange_wires

    public sub pump2_Set_wires()
        ' wire Wire53 is a copy wire
        call Variable1.setIncrementBy(pump2.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'pump2_Set_wires

    public sub LogicalNOR1_TurnOn_wires()
        ' wire Wire52 is sendto wire
        call Variable1.setInput(0)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire59 is sendto wire
        call Add1.setInput2(0)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'LogicalNOR1_TurnOn_wires

    public sub pump1_Set_wires()
        ' wire Wire51 is a copy wire
        call Variable1.setIncrementBy(pump1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'pump1_Set_wires

    public sub LogicalAND3_Change_wires()
        ' wire Wire49 is a copy wire
        call pump2.setEnabled(LogicalAND3.State)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'LogicalAND3_Change_wires

    public sub LogicalAND2_Change_wires()
        ' wire Wire48 is a copy wire
        call pump1.setEnabled(LogicalAND2.State)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'LogicalAND2_Change_wires

    public sub LogicalNOT1_Change_wires()
        ' wire Wire39 is a copy wire
        call LogicalAND2.setInputB(LogicalNOT1.State)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'LogicalNOT1_Change_wires

    public sub LogicalNOT2_Change_wires()
        ' wire Wire30 is a copy wire
        call LogicalAND3.setInputA(LogicalNOT2.State)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'LogicalNOT2_Change_wires

    public sub Subtract1_Change_wires()
        ' wire Wire34 is a copy wire
        call LongRangeRadar2.setAngle(Subtract1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Subtract1_Change_wires

    public sub Add2_Change_wires()
        ' wire Wire33 is a copy wire
        call LongRangeRadar1.setAngle(Add2.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Add2_Change_wires

    public sub Variable1_Change_wires()
        ' wire Wire35 is a copy wire
        call Subtract1.setInput1(Variable1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire36 is a copy wire
        call Add2.setInput1(Variable1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire37 is a copy wire
        call Sonar1.setAngle(Variable1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire54 is a copy wire
        call RangeTest1.setInput(Variable1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Variable1_Change_wires

    public sub LogicalAND1_TurnOn_wires()
        ' wire Wire43 is sendto wire
        call MachineGun3.Fire()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire44 is sendto wire
        call MachineGun2.Fire()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire45 is sendto wire
        call MachineGun1.Fire()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'LogicalAND1_TurnOn_wires

    public sub Filter2_Change_wires()
        ' wire Wire42 is a copy wire
        call LogicalAND1.setInputB(Filter2.State)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire29 is a copy wire
        call LogicalNOT2.setInputA(Filter2.State)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire38 is a copy wire
        call LogicalAND2.setInputA(Filter2.State)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire46 is a copy wire
        call LogicalNOR1.setInputA(Filter2.State)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Filter2_Change_wires

    public sub Filter3_Change_wires()
        ' wire Wire41 is a copy wire
        call LogicalAND1.setInputA(Filter3.State)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire31 is a copy wire
        call LogicalAND3.setInputB(Filter3.State)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire32 is a copy wire
        call LogicalNOT1.setInputA(Filter3.State)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire47 is a copy wire
        call LogicalNOR1.setInputB(Filter3.State)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Filter3_Change_wires

    public sub HealthManager1_UseHP2_wires()
        ' wire Wire40 is sendto wire
        call HealthPack2.Trigger()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'HealthManager1_UseHP2_wires

    public sub LongRangeRadar2_PlugIn_wires()
        ' wire Wire28 is a copy wire
        call Filter2.setFilterSocket(LongRangeRadar2.FilterPlug)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'LongRangeRadar2_PlugIn_wires

    public sub LongRangeRadar1_PlugIn_wires()
        ' wire Wire27 is a copy wire
        call Filter3.setFilterSocket(LongRangeRadar1.FilterPlug)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'LongRangeRadar1_PlugIn_wires

    public sub Filter1_TurnOn_wires()
        ' wire Wire24 is sendto wire
        call MachineGun2.Fire()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire25 is sendto wire
        call MachineGun1.Fire()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire26 is sendto wire
        call MachineGun3.Fire()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Filter1_TurnOn_wires

    public sub Sonar1_PlugIn_wires()
        ' wire Wire23 is a copy wire
        call Filter1.setFilterSocket(Sonar1.FilterPlug)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Sonar1_PlugIn_wires

    public sub LoopTimer1_Tick_wires()
        select case mWireColor
        case 1
            ' wire Wire21 is sendto wire
            call Divide1.setInput1(0)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        end select
        ' wire Wire22 is sendto wire
        call Sonar1.Fire()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'LoopTimer1_Tick_wires

    public sub Add1_Change_wires()
        ' wire Wire20 is a copy wire
        call TrakJack1.setRotation(Add1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Add1_Change_wires

    public sub Divide1_Change_wires()
        select case mWireColor
        case 2
            ' wire Wire18 is a copy wire
            call Add1.setInput1(Divide1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        end select
    end sub 'Divide1_Change_wires

    public sub TrakJack1_Change_wires()
        ' wire Wire16 is a copy wire
        call Thruster1.setThrust(TrakJack1.RTread)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire17 is a copy wire
        call Thruster2.setThrust(TrakJack1.LTread)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'TrakJack1_Change_wires

    public sub Compare2_LessThan_wires()
        ' wire Wire15 is sendto wire
        call ModeSwitch1.setMode(1)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Compare2_LessThan_wires

    public sub Compare1_GreaterThan_wires()
        ' wire Wire13 is sendto wire
        call ModeSwitch1.setMode(2)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Compare1_GreaterThan_wires

    public sub XYFinder1_Change_wires()
        select case mWireColor
        case 2
            ' wire Wire19 is a copy wire
            call Divide1.setInput1(XYFinder1.Bearing)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        end select
        ' wire Wire12 is a copy wire
        call Compare1.setInput1(XYFinder1.Distance)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire14 is a copy wire
        call Compare2.setInput1(XYFinder1.Distance)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'XYFinder1_Change_wires

    public sub Timer2_Tick_wires()
        select case mWireColor
        case 1
            ' wire Wire9 is sendto wire
            call Thruster2.setThrust(100)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

            ' wire Wire8 is sendto wire
            call Thruster1.setThrust(100)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        end select
        ' wire Wire10 is sendto wire
        call Timer1.setTickTime(5)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Timer2_Tick_wires

    public sub Timer1_Tick_wires()
        select case mWireColor
        case 1
            ' wire Wire7 is sendto wire
            call Thruster2.setThrust(-100)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

            ' wire Wire6 is sendto wire
            call Thruster1.setThrust(100)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        end select
        ' wire Wire11 is sendto wire
        call Timer2.setTickTime(6)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Timer1_Tick_wires

    public sub Startup1_Tick_wires()
        ' wire Wire5 is sendto wire
        call ModeSwitch1.setMode(1)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Startup1_Tick_wires

    public sub LogicalReceiver2_NumberReceived_wires()
        ' wire Wire4 is a copy wire
        call XYFinder1.setYPosition(LogicalReceiver2.IncomingNumber)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'LogicalReceiver2_NumberReceived_wires

    public sub LogicalReceiver1_NumberReceived_wires()
        ' wire Wire3 is a copy wire
        call XYFinder1.setXPosition(LogicalReceiver1.IncomingNumber)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'LogicalReceiver1_NumberReceived_wires

    public sub HealthManager1_UseHP1_wires()
        ' wire Wire2 is sendto wire
        call HealthPack1.Trigger()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'HealthManager1_UseHP1_wires

    public sub HealthSensor1_Change_wires()
        ' wire Wire1 is a copy wire
        call HealthManager1.setHealth(HealthSensor1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'HealthSensor1_Change_wires

    public function getChassisName() as string
        getChassisName = "HoverM"
    end function

    public function getDescription() as string
        getDescription = "Created by Black Eagle||Scenario : Rocket Duos||Teammate : InstantLaser||This medium hover is equipped with 3 machine guns.||This hover will constantly move and spin.||It will try to follow its teammate when no enemies are in sight.|"
    end function

    public function specifyComponents() as string
        specifyComponents = "HoverM MachineGun MachineGun MachineGun LongRangeRadar LongRangeRadar Sonar Thruster Thruster HealthPack HealthSensor XYFinder HealthPack HealthManager LogicalReceiver LogicalReceiver ModeSwitch Start"
        specifyComponents = specifyComponents & "up Timer Timer TrakJack Compare Compare Divide Add LoopTimer Filter Filter Filter LogicalAND Add Subtract Variable LogicalAND LogicalNOT LogicalAND LogicalNOT LogicalNOR pump pump RangeTest"
    end function
  
    function loadComponents(vehicleID as integer) as boolean
        loadComponents = false
        if not super.loadComponents(vehicleID) then
           exit function
        end if

        compRegistry as VehicleComponents
        compRegistry = sys.getNamedData("VehicleComponents", "VehicleComponents", mSelf)
        if compRegistry <> null then
           call compRegistry.setVehicleName("HoverHumvee")
        end if

        modeEvent as DataEvent
        ' magic object shared with mode-switch component(s)
        modeEvent = sys.getNamedData("DataEvent", "ModeChange", mSelf)
        if modeEvent = null then
           call sys.printToLog("Vehicle HoverHumvee can't get ModeChange event!")
        else
           modeCatcher as CatchModeChange
           modeCatcher = new CatchModeChange        ' get handler
           modeCatcher.myVehicle = this             ' bind myself
           call modeEvent.register(modeCatcher)     ' then register handler
        end if

        ' initialize MachineGun1
        MachineGun1 = sys.getComponent("MachineGun")
        if MachineGun1 = null then
           call sys.printToLog("HoverHumvee: MachineGun1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(MachineGun1, "MachineGun", "MachineGun1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(MachineGun1, -0.0400656, 0.05, 0) then
            call sys.printToLog("HoverHumvee: MachineGun1 not placed")
            exit function
        end if
        call MachineGun1.setAngle(0)

        ' initialize MachineGun2
        MachineGun2 = sys.getComponent("MachineGun")
        if MachineGun2 = null then
           call sys.printToLog("HoverHumvee: MachineGun2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(MachineGun2, "MachineGun", "MachineGun2")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(MachineGun2, -0.0400656, 0, 0) then
            call sys.printToLog("HoverHumvee: MachineGun2 not placed")
            exit function
        end if
        call MachineGun2.setAngle(0)

        ' initialize MachineGun3
        MachineGun3 = sys.getComponent("MachineGun")
        if MachineGun3 = null then
           call sys.printToLog("HoverHumvee: MachineGun3 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(MachineGun3, "MachineGun", "MachineGun3")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(MachineGun3, -0.0400656, -0.05, 0) then
            call sys.printToLog("HoverHumvee: MachineGun3 not placed")
            exit function
        end if
        call MachineGun3.setAngle(0)

        ' initialize LongRangeRadar1
        LongRangeRadar1 = sys.getComponent("LongRangeRadar")
        if LongRangeRadar1 = null then
           call sys.printToLog("HoverHumvee: LongRangeRadar1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(LongRangeRadar1, "LongRangeRadar", "LongRangeRadar1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(LongRangeRadar1, -0.115066, 0.05, 0) then
            call sys.printToLog("HoverHumvee: LongRangeRadar1 not placed")
            exit function
        end if
        call LongRangeRadar1.setMaxRange(10)
        call LongRangeRadar1.setAngle(15)
        call LongRangeRadar1.setScanWidth(30)

        ' initialize LongRangeRadar2
        LongRangeRadar2 = sys.getComponent("LongRangeRadar")
        if LongRangeRadar2 = null then
           call sys.printToLog("HoverHumvee: LongRangeRadar2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(LongRangeRadar2, "LongRangeRadar", "LongRangeRadar2")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(LongRangeRadar2, -0.115066, -0.05, 0) then
            call sys.printToLog("HoverHumvee: LongRangeRadar2 not placed")
            exit function
        end if
        call LongRangeRadar2.setMaxRange(10)
        call LongRangeRadar2.setAngle(-15)
        call LongRangeRadar2.setScanWidth(30)

        ' initialize Sonar1
        Sonar1 = sys.getComponent("Sonar")
        if Sonar1 = null then
           call sys.printToLog("HoverHumvee: Sonar1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Sonar1, "Sonar", "Sonar1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(Sonar1, -0.115066, 0, 0) then
            call sys.printToLog("HoverHumvee: Sonar1 not placed")
            exit function
        end if
        call Sonar1.setAngle(0)
        call Sonar1.setMaxRange(8)

        ' initialize Thruster1
        Thruster1 = sys.getComponent("Thruster")
        if Thruster1 = null then
           call sys.printToLog("HoverHumvee: Thruster1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Thruster1, "Thruster", "Thruster1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(Thruster1, -0.115066, 0.125, 0) then
            call sys.printToLog("HoverHumvee: Thruster1 not placed")
            exit function
        end if
        call Thruster1.setThrust(100)

        ' initialize Thruster2
        Thruster2 = sys.getComponent("Thruster")
        if Thruster2 = null then
           call sys.printToLog("HoverHumvee: Thruster2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Thruster2, "Thruster", "Thruster2")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(Thruster2, -0.115066, -0.125, 0) then
            call sys.printToLog("HoverHumvee: Thruster2 not placed")
            exit function
        end if
        call Thruster2.setThrust(70)

        ' initialize HealthPack1
        HealthPack1 = sys.getComponent("HealthPack")
        if HealthPack1 = null then
           call sys.printToLog("HoverHumvee: HealthPack1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(HealthPack1, "HealthPack", "HealthPack1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(HealthPack1, -0.0150656, 0.125, 0) then
            call sys.printToLog("HoverHumvee: HealthPack1 not placed")
            exit function
        end if

        ' initialize HealthSensor1
        HealthSensor1 = sys.getComponent("HealthSensor")
        if HealthSensor1 = null then
           call sys.printToLog("HoverHumvee: HealthSensor1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(HealthSensor1, "HealthSensor", "HealthSensor1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(HealthSensor1, -0.0150656, -0.125, 0) then
            call sys.printToLog("HoverHumvee: HealthSensor1 not placed")
            exit function
        end if
        call HealthSensor1.setCritical_pct(25)
        call HealthSensor1.setHealthy_pct(75)

        ' initialize XYFinder1
        XYFinder1 = sys.getComponent("XYFinder")
        if XYFinder1 = null then
           call sys.printToLog("HoverHumvee: XYFinder1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(XYFinder1, "XYFinder", "XYFinder1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(XYFinder1, -0.0650656, 0.125, 0) then
            call sys.printToLog("HoverHumvee: XYFinder1 not placed")
            exit function
        end if
        call XYFinder1.setXPosition(0)
        call XYFinder1.setYPosition(0)

        ' initialize HealthPack2
        HealthPack2 = sys.getComponent("HealthPack")
        if HealthPack2 = null then
           call sys.printToLog("HoverHumvee: HealthPack2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(HealthPack2, "HealthPack", "HealthPack2")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(HealthPack2, -0.0650656, -0.125, 0) then
            call sys.printToLog("HoverHumvee: HealthPack2 not placed")
            exit function
        end if

        ' initialize HealthManager1
        HealthManager1 = sys.getComponent("HealthManager")
        if HealthManager1 = null then
           call sys.printToLog("HoverHumvee: HealthManager1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(HealthManager1, "HealthManager", "HealthManager1")
        end if
        ' Logical component doesn't need to be positioned
        call HealthManager1.setHealth(100)

        ' initialize LogicalReceiver1
        LogicalReceiver1 = sys.getComponent("LogicalReceiver")
        if LogicalReceiver1 = null then
           call sys.printToLog("HoverHumvee: LogicalReceiver1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(LogicalReceiver1, "LogicalReceiver", "LogicalReceiver1")
        end if
        ' Logical component doesn't need to be positioned
        call LogicalReceiver1.setStation(1)

        ' initialize LogicalReceiver2
        LogicalReceiver2 = sys.getComponent("LogicalReceiver")
        if LogicalReceiver2 = null then
           call sys.printToLog("HoverHumvee: LogicalReceiver2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(LogicalReceiver2, "LogicalReceiver", "LogicalReceiver2")
        end if
        ' Logical component doesn't need to be positioned
        call LogicalReceiver2.setStation(2)

        ' initialize ModeSwitch1
        ModeSwitch1 = sys.getComponent("ModeSwitch")
        if ModeSwitch1 = null then
           call sys.printToLog("HoverHumvee: ModeSwitch1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(ModeSwitch1, "ModeSwitch", "ModeSwitch1")
        end if
        ' Logical component doesn't need to be positioned
        call ModeSwitch1.setMode(0)

        ' initialize Startup1
        Startup1 = sys.getComponent("Startup")
        if Startup1 = null then
           call sys.printToLog("HoverHumvee: Startup1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Startup1, "Startup", "Startup1")
        end if
        ' Logical component doesn't need to be positioned

        ' initialize Timer1
        Timer1 = sys.getComponent("Timer")
        if Timer1 = null then
           call sys.printToLog("HoverHumvee: Timer1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Timer1, "Timer", "Timer1")
        end if
        ' Logical component doesn't need to be positioned
        call Timer1.setTickTime(2)

        ' initialize Timer2
        Timer2 = sys.getComponent("Timer")
        if Timer2 = null then
           call sys.printToLog("HoverHumvee: Timer2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Timer2, "Timer", "Timer2")
        end if
        ' Logical component doesn't need to be positioned
        call Timer2.setTickTime(0)

        ' initialize TrakJack1
        TrakJack1 = sys.getComponent("TrakJack")
        if TrakJack1 = null then
           call sys.printToLog("HoverHumvee: TrakJack1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(TrakJack1, "TrakJack", "TrakJack1")
        end if
        ' Logical component doesn't need to be positioned
        call TrakJack1.setRotation(0)
        call TrakJack1.setTravel(100)

        ' initialize Compare1
        Compare1 = sys.getComponent("Compare")
        if Compare1 = null then
           call sys.printToLog("HoverHumvee: Compare1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Compare1, "Compare", "Compare1")
        end if
        ' Logical component doesn't need to be positioned
        call Compare1.setInput1(0)
        call Compare1.setInput2(7)
        call Compare1.setCalc(1)

        ' initialize Compare2
        Compare2 = sys.getComponent("Compare")
        if Compare2 = null then
           call sys.printToLog("HoverHumvee: Compare2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Compare2, "Compare", "Compare2")
        end if
        ' Logical component doesn't need to be positioned
        call Compare2.setInput1(0)
        call Compare2.setInput2(3)
        call Compare2.setCalc(1)

        ' initialize Divide1
        Divide1 = sys.getComponent("Divide")
        if Divide1 = null then
           call sys.printToLog("HoverHumvee: Divide1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Divide1, "Divide", "Divide1")
        end if
        ' Logical component doesn't need to be positioned
        call Divide1.setInput1(0)
        call Divide1.setInput2(1)
        call Divide1.setCalc(1)

        ' initialize Add1
        Add1 = sys.getComponent("Add")
        if Add1 = null then
           call sys.printToLog("HoverHumvee: Add1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Add1, "Add", "Add1")
        end if
        ' Logical component doesn't need to be positioned
        call Add1.setInput1(0)
        call Add1.setInput2(0)

        ' initialize LoopTimer1
        LoopTimer1 = sys.getComponent("LoopTimer")
        if LoopTimer1 = null then
           call sys.printToLog("HoverHumvee: LoopTimer1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(LoopTimer1, "LoopTimer", "LoopTimer1")
        end if
        ' Logical component doesn't need to be positioned
        call LoopTimer1.setTickTime(0.1)

        ' initialize Filter1
        Filter1 = sys.getComponent("Filter")
        if Filter1 = null then
           call sys.printToLog("HoverHumvee: Filter1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Filter1, "Filter", "Filter1")
        end if
        ' Logical component doesn't need to be positioned
        call Filter1.setEnemyVehicle(1)
        call Filter1.setFilterSocket("")
        call Filter1.setOther(0)
        call Filter1.setProjectile(0)
        call Filter1.setTeammate(0)

        ' initialize Filter2
        Filter2 = sys.getComponent("Filter")
        if Filter2 = null then
           call sys.printToLog("HoverHumvee: Filter2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Filter2, "Filter", "Filter2")
        end if
        ' Logical component doesn't need to be positioned
        call Filter2.setEnemyVehicle(1)
        call Filter2.setFilterSocket("")
        call Filter2.setOther(0)
        call Filter2.setProjectile(0)
        call Filter2.setTeammate(0)

        ' initialize Filter3
        Filter3 = sys.getComponent("Filter")
        if Filter3 = null then
           call sys.printToLog("HoverHumvee: Filter3 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Filter3, "Filter", "Filter3")
        end if
        ' Logical component doesn't need to be positioned
        call Filter3.setEnemyVehicle(1)
        call Filter3.setFilterSocket("")
        call Filter3.setOther(0)
        call Filter3.setProjectile(0)
        call Filter3.setTeammate(0)

        ' initialize LogicalAND1
        LogicalAND1 = sys.getComponent("LogicalAND")
        if LogicalAND1 = null then
           call sys.printToLog("HoverHumvee: LogicalAND1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(LogicalAND1, "LogicalAND", "LogicalAND1")
        end if
        ' Logical component doesn't need to be positioned
        call LogicalAND1.setInputA(0)
        call LogicalAND1.setInputB(0)

        ' initialize Add2
        Add2 = sys.getComponent("Add")
        if Add2 = null then
           call sys.printToLog("HoverHumvee: Add2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Add2, "Add", "Add2")
        end if
        ' Logical component doesn't need to be positioned
        call Add2.setInput1(0)
        call Add2.setInput2(15)

        ' initialize Subtract1
        Subtract1 = sys.getComponent("Subtract")
        if Subtract1 = null then
           call sys.printToLog("HoverHumvee: Subtract1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Subtract1, "Subtract", "Subtract1")
        end if
        ' Logical component doesn't need to be positioned
        call Subtract1.setInput1(0)
        call Subtract1.setInput2(15)

        ' initialize Variable1
        Variable1 = sys.getComponent("Variable")
        if Variable1 = null then
           call sys.printToLog("HoverHumvee: Variable1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Variable1, "Variable", "Variable1")
        end if
        ' Logical component doesn't need to be positioned
        call Variable1.setInput(0)

        ' initialize LogicalAND2
        LogicalAND2 = sys.getComponent("LogicalAND")
        if LogicalAND2 = null then
           call sys.printToLog("HoverHumvee: LogicalAND2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(LogicalAND2, "LogicalAND", "LogicalAND2")
        end if
        ' Logical component doesn't need to be positioned
        call LogicalAND2.setInputA(0)
        call LogicalAND2.setInputB(0)

        ' initialize LogicalNOT1
        LogicalNOT1 = sys.getComponent("LogicalNOT")
        if LogicalNOT1 = null then
           call sys.printToLog("HoverHumvee: LogicalNOT1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(LogicalNOT1, "LogicalNOT", "LogicalNOT1")
        end if
        ' Logical component doesn't need to be positioned
        call LogicalNOT1.setInputA(1)

        ' initialize LogicalAND3
        LogicalAND3 = sys.getComponent("LogicalAND")
        if LogicalAND3 = null then
           call sys.printToLog("HoverHumvee: LogicalAND3 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(LogicalAND3, "LogicalAND", "LogicalAND3")
        end if
        ' Logical component doesn't need to be positioned
        call LogicalAND3.setInputA(0)
        call LogicalAND3.setInputB(0)

        ' initialize LogicalNOT2
        LogicalNOT2 = sys.getComponent("LogicalNOT")
        if LogicalNOT2 = null then
           call sys.printToLog("HoverHumvee: LogicalNOT2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(LogicalNOT2, "LogicalNOT", "LogicalNOT2")
        end if
        ' Logical component doesn't need to be positioned
        call LogicalNOT2.setInputA(1)

        ' initialize LogicalNOR1
        LogicalNOR1 = sys.getComponent("LogicalNOR")
        if LogicalNOR1 = null then
           call sys.printToLog("HoverHumvee: LogicalNOR1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(LogicalNOR1, "LogicalNOR", "LogicalNOR1")
        end if
        ' Logical component doesn't need to be positioned
        call LogicalNOR1.setInputA(0)
        call LogicalNOR1.setInputB(0)

        ' initialize pump1
        pump1 = sys.getComponent("pump")
        if pump1 = null then
           call sys.printToLog("HoverHumvee: pump1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(pump1, "pump", "pump1")
        end if
        ' Logical component doesn't need to be positioned
        call pump1.setInput(-3)
        call pump1.setEnabled(0)
        call pump1.settickTime(0.1)

        ' initialize pump2
        pump2 = sys.getComponent("pump")
        if pump2 = null then
           call sys.printToLog("HoverHumvee: pump2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(pump2, "pump", "pump2")
        end if
        ' Logical component doesn't need to be positioned
        call pump2.setInput(3)
        call pump2.setEnabled(0)
        call pump2.settickTime(0.1)

        ' initialize RangeTest1
        RangeTest1 = sys.getComponent("RangeTest")
        if RangeTest1 = null then
           call sys.printToLog("HoverHumvee: RangeTest1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(RangeTest1, "RangeTest", "RangeTest1")
        end if
        ' Logical component doesn't need to be positioned
        call RangeTest1.setMaximum(45)
        call RangeTest1.setMinimum(-45)
        call RangeTest1.setInput(0)

        call LogicalAND3.TurnOn.register(LogicalAND3_TurnOn_wires)
        call LogicalAND2.TurnOn.register(LogicalAND2_TurnOn_wires)
        call RangeTest1.BelowRange.register(RangeTest1_BelowRange_wires)
        call RangeTest1.AboveRange.register(RangeTest1_AboveRange_wires)
        call pump2.Set.register(pump2_Set_wires)
        call LogicalNOR1.TurnOn.register(LogicalNOR1_TurnOn_wires)
        call pump1.Set.register(pump1_Set_wires)
        call LogicalAND3.Change.register(LogicalAND3_Change_wires)
        call LogicalAND2.Change.register(LogicalAND2_Change_wires)
        call LogicalNOT1.Change.register(LogicalNOT1_Change_wires)
        call LogicalNOT2.Change.register(LogicalNOT2_Change_wires)
        call Subtract1.Change.register(Subtract1_Change_wires)
        call Add2.Change.register(Add2_Change_wires)
        call Variable1.Change.register(Variable1_Change_wires)
        call LogicalAND1.TurnOn.register(LogicalAND1_TurnOn_wires)
        call Filter2.Change.register(Filter2_Change_wires)
        call Filter3.Change.register(Filter3_Change_wires)
        call HealthManager1.UseHP2.register(HealthManager1_UseHP2_wires)
        call LongRangeRadar2.PlugIn.register(LongRangeRadar2_PlugIn_wires)
        call LongRangeRadar1.PlugIn.register(LongRangeRadar1_PlugIn_wires)
        call Filter1.TurnOn.register(Filter1_TurnOn_wires)
        call Sonar1.PlugIn.register(Sonar1_PlugIn_wires)
        call LoopTimer1.Tick.register(LoopTimer1_Tick_wires)
        call Add1.Change.register(Add1_Change_wires)
        call Divide1.Change.register(Divide1_Change_wires)
        call TrakJack1.Change.register(TrakJack1_Change_wires)
        call Compare2.LessThan.register(Compare2_LessThan_wires)
        call Compare1.GreaterThan.register(Compare1_GreaterThan_wires)
        call XYFinder1.Change.register(XYFinder1_Change_wires)
        call Timer2.Tick.register(Timer2_Tick_wires)
        call Timer1.Tick.register(Timer1_Tick_wires)
        call Startup1.Tick.register(Startup1_Tick_wires)
        call LogicalReceiver2.NumberReceived.register(LogicalReceiver2_NumberReceived_wires)
        call LogicalReceiver1.NumberReceived.register(LogicalReceiver1_NumberReceived_wires)
        call HealthManager1.UseHP1.register(HealthManager1_UseHP1_wires)
        call HealthSensor1.Change.register(HealthSensor1_Change_wires)

  ' *** place user initialization here ***
  ' *** end of user initialization ***

        loadComponents = true           ' if we got this far, we succeeded
    end function 'loadComponents

    sub init(sysobj as VehicleSystemObject)
        sys = sysobj
  ' *** place user variable init here ***
  ' *** end of user variable init ***
    end sub 'init

end class 'HoverHumvee
' END TEMPLATE
