' TEMPLATE

' NOTE: This file is generated automatically. Do not make modifications
' outside the designated areas; if you do, your changes may be lost.


' private helper class
class CatchModeChange extends DataEventHandler
  myVehicle as Vehicle

  sub handle(name as string, data as EventData)
    call myVehicle.setWireColor(data.getInt())
  end sub 'handle
end class 'CatchModeChange

  ' *** place user const declarations here ***
  ' *** end of user const declarations ***

class TheFollower extends Vehicle
    sys as VehicleSystemObject
    
    Steering1 as Steering
    RocketLauncher1 as RocketLauncher
    HealthSensor1 as HealthSensor
    BattleLaser1 as BattleLaser
    BattleLaser4 as BattleLaser
    BattleLaser5 as BattleLaser
    Sonar1 as Sonar
    MediumEngine1 as MediumEngine
    BattleLaser3 as BattleLaser
    LongRangeRadar1 as LongRangeRadar
    XYFinder1 as XYFinder
    HealthPack1 as HealthPack
    LogicalReceiver1 as LogicalReceiver
    LogicalReceiver2 as LogicalReceiver
    Divide1 as Divide
    Add1 as Add
    LoopTimer1 as LoopTimer
    Startup1 as Startup
    Variable1 as Variable
    Sweeper1 as Sweeper
    rectifier1 as rectifier
    Filter1 as Filter
    ModeSwitch1 as ModeSwitch
    Filter2 as Filter
    LoopTimer2 as LoopTimer
    Subtract1 as Subtract

  ' *** place vehicle data and subs here ***
  ' *** end of vehicle data and subs ***

    public function getGroup() as string
        getGroup = "Battle"
    end function 'getGroup

    public function getVer() as float
        getVer = 1.01
    end function 'getVer

    public sub LoopTimer1_Tick_wires()
        ' wire Wire7 is sendto wire
        call RocketLauncher1.Fire()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'LoopTimer1_Tick_wires

    public sub Subtract1_Change_wires()
        select case mWireColor
        case 2
            ' wire Wire23 is a copy wire
            call Variable1.setInput(Subtract1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        end select
    end sub 'Subtract1_Change_wires

    public sub Filter1_TurnOff_wires()
        ' wire Wire21 is sendto wire
        call ModeSwitch1.setMode(1)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Filter1_TurnOff_wires

    public sub Filter1_TurnOn_wires()
        ' wire Wire20 is sendto wire
        call ModeSwitch1.setMode(2)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Filter1_TurnOn_wires

    public sub LongRangeRadar1_PlugIn_wires()
        ' wire Wire19 is a copy wire
        call Filter1.setFilterSocket(LongRangeRadar1.FilterPlug)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'LongRangeRadar1_PlugIn_wires

    public sub rectifier1_Change_wires()
        ' wire Wire18 is a copy wire
        call Variable1.setInput(rectifier1.Angle)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'rectifier1_Change_wires

    public sub Variable1_Change_wires()
        ' wire Wire17 is a copy wire
        call rectifier1.setInput(Variable1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire24 is a copy wire
        call Sonar1.setAngle(Variable1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire25 is a copy wire
        call BattleLaser4.setAngle(Variable1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire26 is a copy wire
        call BattleLaser1.setAngle(Variable1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire27 is a copy wire
        call BattleLaser3.setAngle(Variable1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire28 is a copy wire
        call BattleLaser5.setAngle(Variable1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Variable1_Change_wires

    public sub LoopTimer2_Tick_wires()
        ' wire Wire15 is sendto wire
        call Variable1.setIncrementBy(4)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire16 is sendto wire
        call Sonar1.Fire()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'LoopTimer2_Tick_wires

    public sub Sweeper1_Change_wires()
        select case mWireColor
        case 2
            ' wire Wire22 is a copy wire
            call Subtract1.setInput1(Sweeper1.Angle)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        end select
        ' wire Wire14 is a copy wire
        call LongRangeRadar1.setAngle(Sweeper1.Angle)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Sweeper1_Change_wires

    public sub Filter2_TurnOn_wires()
        ' wire Wire10 is sendto wire
        call BattleLaser1.Fire()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire11 is sendto wire
        call BattleLaser3.Fire()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire12 is sendto wire
        call BattleLaser5.Fire()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire13 is sendto wire
        call BattleLaser4.Fire()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Filter2_TurnOn_wires

    public sub Sonar1_PlugIn_wires()
        ' wire Wire9 is a copy wire
        call Filter2.setFilterSocket(Sonar1.FilterPlug)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Sonar1_PlugIn_wires

    public sub Startup1_Tick_wires()
        ' wire Wire8 is sendto wire
        call RocketLauncher1.Fire()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Startup1_Tick_wires

    public sub Add1_Change_wires()
        ' wire Wire6 is a copy wire
        call Steering1.setAngle(Add1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Add1_Change_wires

    public sub Divide1_Change_wires()
        ' wire Wire5 is a copy wire
        call Add1.setInput1(Divide1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Divide1_Change_wires

    public sub XYFinder1_Change_wires()
        ' wire Wire4 is a copy wire
        call Divide1.setInput1(XYFinder1.Bearing)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'XYFinder1_Change_wires

    public sub LogicalReceiver2_NumberReceived_wires()
        ' wire Wire3 is a copy wire
        call XYFinder1.setYPosition(LogicalReceiver2.IncomingNumber)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'LogicalReceiver2_NumberReceived_wires

    public sub LogicalReceiver1_NumberReceived_wires()
        ' wire Wire2 is a copy wire
        call XYFinder1.setXPosition(LogicalReceiver1.IncomingNumber)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'LogicalReceiver1_NumberReceived_wires

    public sub HealthSensor1_CriticalDamage_wires()
        ' wire Wire1 is sendto wire
        call HealthPack1.Trigger()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'HealthSensor1_CriticalDamage_wires

    public function getChassisName() as string
        getChassisName = "WheelL"
    end function

    public function getDescription() as string
        getDescription = "Created by Black Eagle||Scenario : Rocket Duos||Teammate : ThePointer||Follows the teammate. Has 4 Battle Lasers and a Rocket Launcher.|"
    end function

    public function specifyComponents() as string
        specifyComponents = "WheelL Steering RocketLauncher HealthSensor BattleLaser BattleLaser BattleLaser Sonar MediumEngine BattleLaser LongRangeRadar XYFinder HealthPack LogicalReceiver LogicalReceiver Divide Add LoopTimer S"
        specifyComponents = specifyComponents & "tartup Variable Sweeper rectifier Filter ModeSwitch Filter LoopTimer Subtract"
    end function
  
    function loadComponents(vehicleID as integer) as boolean
        loadComponents = false
        if not super.loadComponents(vehicleID) then
           exit function
        end if

        compRegistry as VehicleComponents
        compRegistry = sys.getNamedData("VehicleComponents", "VehicleComponents", mSelf)
        if compRegistry <> null then
           call compRegistry.setVehicleName("TheFollower")
        end if

        modeEvent as DataEvent
        ' magic object shared with mode-switch component(s)
        modeEvent = sys.getNamedData("DataEvent", "ModeChange", mSelf)
        if modeEvent = null then
           call sys.printToLog("Vehicle TheFollower can't get ModeChange event!")
        else
           modeCatcher as CatchModeChange
           modeCatcher = new CatchModeChange        ' get handler
           modeCatcher.myVehicle = this             ' bind myself
           call modeEvent.register(modeCatcher)     ' then register handler
        end if

        ' initialize Steering1
        Steering1 = sys.getComponent("Steering")
        if Steering1 = null then
           call sys.printToLog("TheFollower: Steering1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Steering1, "Steering", "Steering1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(Steering1, -0.009, -0.125, 0) then
            call sys.printToLog("TheFollower: Steering1 not placed")
            exit function
        end if
        call Steering1.setAngle(0)

        ' initialize RocketLauncher1
        RocketLauncher1 = sys.getComponent("RocketLauncher")
        if RocketLauncher1 = null then
           call sys.printToLog("TheFollower: RocketLauncher1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(RocketLauncher1, "RocketLauncher", "RocketLauncher1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(RocketLauncher1, -0.084, 0.125, 2) then
            call sys.printToLog("TheFollower: RocketLauncher1 not placed")
            exit function
        end if
        call RocketLauncher1.setRocketSpeed(1)

        ' initialize HealthSensor1
        HealthSensor1 = sys.getComponent("HealthSensor")
        if HealthSensor1 = null then
           call sys.printToLog("TheFollower: HealthSensor1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(HealthSensor1, "HealthSensor", "HealthSensor1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(HealthSensor1, -0.009, 0.125, 0) then
            call sys.printToLog("TheFollower: HealthSensor1 not placed")
            exit function
        end if
        call HealthSensor1.setCritical_pct(50)
        call HealthSensor1.setHealthy_pct(75)

        ' initialize BattleLaser1
        BattleLaser1 = sys.getComponent("BattleLaser")
        if BattleLaser1 = null then
           call sys.printToLog("TheFollower: BattleLaser1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(BattleLaser1, "BattleLaser", "BattleLaser1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(BattleLaser1, -0.071, 0.05, 0) then
            call sys.printToLog("TheFollower: BattleLaser1 not placed")
            exit function
        end if
        call BattleLaser1.setAngle(0)
        call BattleLaser1.setPower(2)

        ' initialize BattleLaser4
        BattleLaser4 = sys.getComponent("BattleLaser")
        if BattleLaser4 = null then
           call sys.printToLog("TheFollower: BattleLaser4 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(BattleLaser4, "BattleLaser", "BattleLaser4")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(BattleLaser4, 0.029, 0.05, 0) then
            call sys.printToLog("TheFollower: BattleLaser4 not placed")
            exit function
        end if
        call BattleLaser4.setAngle(0)
        call BattleLaser4.setPower(2)

        ' initialize BattleLaser5
        BattleLaser5 = sys.getComponent("BattleLaser")
        if BattleLaser5 = null then
           call sys.printToLog("TheFollower: BattleLaser5 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(BattleLaser5, "BattleLaser", "BattleLaser5")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(BattleLaser5, 0.029, -0.05, 0) then
            call sys.printToLog("TheFollower: BattleLaser5 not placed")
            exit function
        end if
        call BattleLaser5.setAngle(0)
        call BattleLaser5.setPower(2)

        ' initialize Sonar1
        Sonar1 = sys.getComponent("Sonar")
        if Sonar1 = null then
           call sys.printToLog("TheFollower: Sonar1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Sonar1, "Sonar", "Sonar1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(Sonar1, 0.004, 0, 0) then
            call sys.printToLog("TheFollower: Sonar1 not placed")
            exit function
        end if
        call Sonar1.setAngle(0)
        call Sonar1.setMaxRange(10)

        ' initialize MediumEngine1
        MediumEngine1 = sys.getComponent("MediumEngine")
        if MediumEngine1 = null then
           call sys.printToLog("TheFollower: MediumEngine1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(MediumEngine1, "MediumEngine", "MediumEngine1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(MediumEngine1, -0.071, -0.05, 0) then
            call sys.printToLog("TheFollower: MediumEngine1 not placed")
            exit function
        end if
        call MediumEngine1.setThrottle(100)

        ' initialize BattleLaser3
        BattleLaser3 = sys.getComponent("BattleLaser")
        if BattleLaser3 = null then
           call sys.printToLog("TheFollower: BattleLaser3 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(BattleLaser3, "BattleLaser", "BattleLaser3")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(BattleLaser3, -0.071, 0, 0) then
            call sys.printToLog("TheFollower: BattleLaser3 not placed")
            exit function
        end if
        call BattleLaser3.setAngle(0)
        call BattleLaser3.setPower(2)

        ' initialize LongRangeRadar1
        LongRangeRadar1 = sys.getComponent("LongRangeRadar")
        if LongRangeRadar1 = null then
           call sys.printToLog("TheFollower: LongRangeRadar1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(LongRangeRadar1, "LongRangeRadar", "LongRangeRadar1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(LongRangeRadar1, 0.054, 0, 0) then
            call sys.printToLog("TheFollower: LongRangeRadar1 not placed")
            exit function
        end if
        call LongRangeRadar1.setMaxRange(10)
        call LongRangeRadar1.setAngle(0)
        call LongRangeRadar1.setScanWidth(30)

        ' initialize XYFinder1
        XYFinder1 = sys.getComponent("XYFinder")
        if XYFinder1 = null then
           call sys.printToLog("TheFollower: XYFinder1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(XYFinder1, "XYFinder", "XYFinder1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(XYFinder1, 0.176, 0.11, 0) then
            call sys.printToLog("TheFollower: XYFinder1 not placed")
            exit function
        end if
        call XYFinder1.setXPosition(0)
        call XYFinder1.setYPosition(0)

        ' initialize HealthPack1
        HealthPack1 = sys.getComponent("HealthPack")
        if HealthPack1 = null then
           call sys.printToLog("TheFollower: HealthPack1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(HealthPack1, "HealthPack", "HealthPack1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(HealthPack1, 0.176, -0.11, 0) then
            call sys.printToLog("TheFollower: HealthPack1 not placed")
            exit function
        end if

        ' initialize LogicalReceiver1
        LogicalReceiver1 = sys.getComponent("LogicalReceiver")
        if LogicalReceiver1 = null then
           call sys.printToLog("TheFollower: LogicalReceiver1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(LogicalReceiver1, "LogicalReceiver", "LogicalReceiver1")
        end if
        ' Logical component doesn't need to be positioned
        call LogicalReceiver1.setStation(1)

        ' initialize LogicalReceiver2
        LogicalReceiver2 = sys.getComponent("LogicalReceiver")
        if LogicalReceiver2 = null then
           call sys.printToLog("TheFollower: LogicalReceiver2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(LogicalReceiver2, "LogicalReceiver", "LogicalReceiver2")
        end if
        ' Logical component doesn't need to be positioned
        call LogicalReceiver2.setStation(2)

        ' initialize Divide1
        Divide1 = sys.getComponent("Divide")
        if Divide1 = null then
           call sys.printToLog("TheFollower: Divide1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Divide1, "Divide", "Divide1")
        end if
        ' Logical component doesn't need to be positioned
        call Divide1.setInput1(0)
        call Divide1.setInput2(7)
        call Divide1.setCalc(1)

        ' initialize Add1
        Add1 = sys.getComponent("Add")
        if Add1 = null then
           call sys.printToLog("TheFollower: Add1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Add1, "Add", "Add1")
        end if
        ' Logical component doesn't need to be positioned
        call Add1.setInput1(0)
        call Add1.setInput2(0)

        ' initialize LoopTimer1
        LoopTimer1 = sys.getComponent("LoopTimer")
        if LoopTimer1 = null then
           call sys.printToLog("TheFollower: LoopTimer1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(LoopTimer1, "LoopTimer", "LoopTimer1")
        end if
        ' Logical component doesn't need to be positioned
        call LoopTimer1.setTickTime(0.1)

        ' initialize Startup1
        Startup1 = sys.getComponent("Startup")
        if Startup1 = null then
           call sys.printToLog("TheFollower: Startup1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Startup1, "Startup", "Startup1")
        end if
        ' Logical component doesn't need to be positioned

        ' initialize Variable1
        Variable1 = sys.getComponent("Variable")
        if Variable1 = null then
           call sys.printToLog("TheFollower: Variable1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Variable1, "Variable", "Variable1")
        end if
        ' Logical component doesn't need to be positioned
        call Variable1.setInput(0)

        ' initialize Sweeper1
        Sweeper1 = sys.getComponent("Sweeper")
        if Sweeper1 = null then
           call sys.printToLog("TheFollower: Sweeper1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Sweeper1, "Sweeper", "Sweeper1")
        end if
        ' Logical component doesn't need to be positioned
        call Sweeper1.setminAngle(-180)
        call Sweeper1.setmaxAngle(180)
        call Sweeper1.setIncrement(30)
        call Sweeper1.settickTime(0.1)
        call Sweeper1.setAngle(0)

        ' initialize rectifier1
        rectifier1 = sys.getComponent("rectifier")
        if rectifier1 = null then
           call sys.printToLog("TheFollower: rectifier1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(rectifier1, "rectifier", "rectifier1")
        end if
        ' Logical component doesn't need to be positioned
        call rectifier1.setInput(0)

        ' initialize Filter1
        Filter1 = sys.getComponent("Filter")
        if Filter1 = null then
           call sys.printToLog("TheFollower: Filter1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Filter1, "Filter", "Filter1")
        end if
        ' Logical component doesn't need to be positioned
        call Filter1.setEnemyVehicle(1)
        call Filter1.setFilterSocket("")
        call Filter1.setOther(0)
        call Filter1.setProjectile(0)
        call Filter1.setTeammate(0)

        ' initialize ModeSwitch1
        ModeSwitch1 = sys.getComponent("ModeSwitch")
        if ModeSwitch1 = null then
           call sys.printToLog("TheFollower: ModeSwitch1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(ModeSwitch1, "ModeSwitch", "ModeSwitch1")
        end if
        ' Logical component doesn't need to be positioned
        call ModeSwitch1.setMode(1)

        ' initialize Filter2
        Filter2 = sys.getComponent("Filter")
        if Filter2 = null then
           call sys.printToLog("TheFollower: Filter2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Filter2, "Filter", "Filter2")
        end if
        ' Logical component doesn't need to be positioned
        call Filter2.setEnemyVehicle(1)
        call Filter2.setFilterSocket("")
        call Filter2.setOther(0)
        call Filter2.setProjectile(0)
        call Filter2.setTeammate(0)

        ' initialize LoopTimer2
        LoopTimer2 = sys.getComponent("LoopTimer")
        if LoopTimer2 = null then
           call sys.printToLog("TheFollower: LoopTimer2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(LoopTimer2, "LoopTimer", "LoopTimer2")
        end if
        ' Logical component doesn't need to be positioned
        call LoopTimer2.setTickTime(0.1)

        ' initialize Subtract1
        Subtract1 = sys.getComponent("Subtract")
        if Subtract1 = null then
           call sys.printToLog("TheFollower: Subtract1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Subtract1, "Subtract", "Subtract1")
        end if
        ' Logical component doesn't need to be positioned
        call Subtract1.setInput1(0)
        call Subtract1.setInput2(45)

        call LoopTimer1.Tick.register(LoopTimer1_Tick_wires)
        call Subtract1.Change.register(Subtract1_Change_wires)
        call Filter1.TurnOff.register(Filter1_TurnOff_wires)
        call Filter1.TurnOn.register(Filter1_TurnOn_wires)
        call LongRangeRadar1.PlugIn.register(LongRangeRadar1_PlugIn_wires)
        call rectifier1.Change.register(rectifier1_Change_wires)
        call Variable1.Change.register(Variable1_Change_wires)
        call LoopTimer2.Tick.register(LoopTimer2_Tick_wires)
        call Sweeper1.Change.register(Sweeper1_Change_wires)
        call Filter2.TurnOn.register(Filter2_TurnOn_wires)
        call Sonar1.PlugIn.register(Sonar1_PlugIn_wires)
        call Startup1.Tick.register(Startup1_Tick_wires)
        call Add1.Change.register(Add1_Change_wires)
        call Divide1.Change.register(Divide1_Change_wires)
        call XYFinder1.Change.register(XYFinder1_Change_wires)
        call LogicalReceiver2.NumberReceived.register(LogicalReceiver2_NumberReceived_wires)
        call LogicalReceiver1.NumberReceived.register(LogicalReceiver1_NumberReceived_wires)
        call HealthSensor1.CriticalDamage.register(HealthSensor1_CriticalDamage_wires)

  ' *** place user initialization here ***
  ' *** end of user initialization ***

        loadComponents = true           ' if we got this far, we succeeded
    end function 'loadComponents

    sub init(sysobj as VehicleSystemObject)
        sys = sysobj
  ' *** place user variable init here ***
  ' *** end of user variable init ***
    end sub 'init

end class 'TheFollower
' END TEMPLATE
