' TEMPLATE

' NOTE: This file is generated automatically. Do not make modifications
' outside the designated areas; if you do, your changes may be lost.


' private helper class
class CatchModeChange extends DataEventHandler
  myVehicle as Vehicle

  sub handle(name as string, data as EventData)
    call myVehicle.setWireColor(data.getInt())
  end sub 'handle
end class 'CatchModeChange

  ' *** place user const declarations here ***
  ' *** end of user const declarations ***

class ThePointer extends Vehicle
    sys as VehicleSystemObject
    
    BattleLaser1 as BattleLaser
    BattleLaser2 as BattleLaser
    Sonar1 as Sonar
    LongRangeRadar1 as LongRangeRadar
    WaypointSensor1 as WaypointSensor
    Steering1 as Steering
    XYSensor1 as XYSensor
    HealthSensor1 as HealthSensor
    HealthPack1 as HealthPack
    MediumEngine1 as MediumEngine
    Divide1 as Divide
    Add1 as Add
    Compare1 as Compare
    Variable1 as Variable
    RangeTest1 as RangeTest
    Sweeper1 as Sweeper
    Filter1 as Filter
    Filter2 as Filter
    LogicalTransmitter1 as LogicalTransmitter
    LogicalTransmitter2 as LogicalTransmitter
    Variable2 as Variable
    LoopTimer1 as LoopTimer
    rectifier1 as rectifier
    ModeSwitch1 as ModeSwitch
    Subtract1 as Subtract

  ' *** place vehicle data and subs here ***
  ' *** end of vehicle data and subs ***

    public function getGroup() as string
        getGroup = "Battle"
    end function 'getGroup

    public function getVer() as float
        getVer = 1.01
    end function 'getVer

    public sub XYSensor1_Change_wires()
        ' wire Wire8 is a copy wire
        call LogicalTransmitter1.setSendNumber(XYSensor1.XPosition)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire9 is a copy wire
        call LogicalTransmitter2.setSendNumber(XYSensor1.YPosition)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'XYSensor1_Change_wires

    public sub HealthSensor1_CriticalDamage_wires()
        ' wire Wire27 is sendto wire
        call HealthPack1.Trigger()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'HealthSensor1_CriticalDamage_wires

    public sub Subtract1_Change_wires()
        select case mWireColor
        case 2
            ' wire Wire22 is a copy wire
            call Variable2.setInput(Subtract1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        end select
    end sub 'Subtract1_Change_wires

    public sub Filter1_TurnOn_wires()
        ' wire Wire20 is sendto wire
        call ModeSwitch1.setMode(2)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Filter1_TurnOn_wires

    public sub Filter1_TurnOff_wires()
        ' wire Wire19 is sendto wire
        call ModeSwitch1.setMode(1)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Filter1_TurnOff_wires

    public sub rectifier1_Change_wires()
        ' wire Wire25 is a copy wire
        call Variable2.setInput(rectifier1.Angle)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'rectifier1_Change_wires

    public sub LoopTimer1_Tick_wires()
        ' wire Wire18 is sendto wire
        call Sonar1.Fire()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire23 is sendto wire
        call Variable2.setIncrementBy(4)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'LoopTimer1_Tick_wires

    public sub Variable2_Change_wires()
        ' wire Wire13 is a copy wire
        call Sonar1.setAngle(Variable2.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire14 is a copy wire
        call BattleLaser1.setAngle(Variable2.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire15 is a copy wire
        call BattleLaser2.setAngle(Variable2.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire24 is a copy wire
        call rectifier1.setInput(Variable2.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Variable2_Change_wires

    public sub LongRangeRadar1_PlugIn_wires()
        ' wire Wire17 is a copy wire
        call Filter1.setFilterSocket(LongRangeRadar1.FilterPlug)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'LongRangeRadar1_PlugIn_wires

    public sub Sweeper1_Change_wires()
        select case mWireColor
        case 2
            ' wire Wire21 is a copy wire
            call Subtract1.setInput1(Sweeper1.Angle)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        end select
        ' wire Wire16 is a copy wire
        call LongRangeRadar1.setAngle(Sweeper1.Angle)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Sweeper1_Change_wires

    public sub Filter2_TurnOn_wires()
        ' wire Wire11 is sendto wire
        call BattleLaser1.Fire()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire12 is sendto wire
        call BattleLaser2.Fire()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Filter2_TurnOn_wires

    public sub Sonar1_PlugIn_wires()
        ' wire Wire10 is a copy wire
        call Filter2.setFilterSocket(Sonar1.FilterPlug)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Sonar1_PlugIn_wires

    public sub RangeTest1_AboveRange_wires()
        ' wire Wire7 is a copy wire
        call Variable1.setInput(RangeTest1.Minimum)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'RangeTest1_AboveRange_wires

    public sub Variable1_Change_wires()
        ' wire Wire6 is a copy wire
        call RangeTest1.setInput(Variable1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire26 is a copy wire
        call WaypointSensor1.setCurrentWaypoint(Variable1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Variable1_Change_wires

    public sub Compare1_LessThan_wires()
        ' wire Wire5 is sendto wire
        call Variable1.setIncrementBy(1)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Compare1_LessThan_wires

    public sub Add1_Change_wires()
        ' wire Wire3 is a copy wire
        call Steering1.setAngle(Add1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Add1_Change_wires

    public sub Divide1_Change_wires()
        ' wire Wire2 is a copy wire
        call Add1.setInput1(Divide1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Divide1_Change_wires

    public sub WaypointSensor1_Change_wires()
        ' wire Wire1 is a copy wire
        call Divide1.setInput1(WaypointSensor1.Bearing)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire4 is a copy wire
        call Compare1.setInput1(WaypointSensor1.Distance)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'WaypointSensor1_Change_wires

    public function getChassisName() as string
        getChassisName = "WheelM"
    end function

    public function getDescription() as string
        getDescription = "Created by Black Eagle||Scenario : Rocket Duos||Teammate : TheFollower||Leads the teammate. Has 2 Battle Lasers/|"
    end function

    public function specifyComponents() as string
        specifyComponents = "WheelM BattleLaser BattleLaser Sonar LongRangeRadar WaypointSensor Steering XYSensor HealthSensor HealthPack MediumEngine Divide Add Compare Variable RangeTest Sweeper Filter Filter LogicalTransmitter"
        specifyComponents = specifyComponents & " LogicalTransmitter Variable LoopTimer rectifier ModeSwitch Subtract"
    end function
  
    function loadComponents(vehicleID as integer) as boolean
        loadComponents = false
        if not super.loadComponents(vehicleID) then
           exit function
        end if

        compRegistry as VehicleComponents
        compRegistry = sys.getNamedData("VehicleComponents", "VehicleComponents", mSelf)
        if compRegistry <> null then
           call compRegistry.setVehicleName("ThePointer")
        end if

        modeEvent as DataEvent
        ' magic object shared with mode-switch component(s)
        modeEvent = sys.getNamedData("DataEvent", "ModeChange", mSelf)
        if modeEvent = null then
           call sys.printToLog("Vehicle ThePointer can't get ModeChange event!")
        else
           modeCatcher as CatchModeChange
           modeCatcher = new CatchModeChange        ' get handler
           modeCatcher.myVehicle = this             ' bind myself
           call modeEvent.register(modeCatcher)     ' then register handler
        end if

        ' initialize BattleLaser1
        BattleLaser1 = sys.getComponent("BattleLaser")
        if BattleLaser1 = null then
           call sys.printToLog("ThePointer: BattleLaser1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(BattleLaser1, "BattleLaser", "BattleLaser1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(BattleLaser1, -0.0143064, 0.05, 0) then
            call sys.printToLog("ThePointer: BattleLaser1 not placed")
            exit function
        end if
        call BattleLaser1.setAngle(0)
        call BattleLaser1.setPower(2)

        ' initialize BattleLaser2
        BattleLaser2 = sys.getComponent("BattleLaser")
        if BattleLaser2 = null then
           call sys.printToLog("ThePointer: BattleLaser2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(BattleLaser2, "BattleLaser", "BattleLaser2")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(BattleLaser2, -0.0143064, -0.05, 0) then
            call sys.printToLog("ThePointer: BattleLaser2 not placed")
            exit function
        end if
        call BattleLaser2.setAngle(0)
        call BattleLaser2.setPower(2)

        ' initialize Sonar1
        Sonar1 = sys.getComponent("Sonar")
        if Sonar1 = null then
           call sys.printToLog("ThePointer: Sonar1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Sonar1, "Sonar", "Sonar1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(Sonar1, 0.0106936, 0, 0) then
            call sys.printToLog("ThePointer: Sonar1 not placed")
            exit function
        end if
        call Sonar1.setAngle(0)
        call Sonar1.setMaxRange(10)

        ' initialize LongRangeRadar1
        LongRangeRadar1 = sys.getComponent("LongRangeRadar")
        if LongRangeRadar1 = null then
           call sys.printToLog("ThePointer: LongRangeRadar1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(LongRangeRadar1, "LongRangeRadar", "LongRangeRadar1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(LongRangeRadar1, -0.0393064, 0, 0) then
            call sys.printToLog("ThePointer: LongRangeRadar1 not placed")
            exit function
        end if
        call LongRangeRadar1.setMaxRange(10)
        call LongRangeRadar1.setAngle(0)
        call LongRangeRadar1.setScanWidth(30)

        ' initialize WaypointSensor1
        WaypointSensor1 = sys.getComponent("WaypointSensor")
        if WaypointSensor1 = null then
           call sys.printToLog("ThePointer: WaypointSensor1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(WaypointSensor1, "WaypointSensor", "WaypointSensor1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(WaypointSensor1, -0.134306, 0, 0) then
            call sys.printToLog("ThePointer: WaypointSensor1 not placed")
            exit function
        end if
        call WaypointSensor1.setCurrentWaypoint(1)
        call WaypointSensor1.setWaypointList("abcdkjihefg")

        ' initialize Steering1
        Steering1 = sys.getComponent("Steering")
        if Steering1 = null then
           call sys.printToLog("ThePointer: Steering1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Steering1, "Steering", "Steering1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(Steering1, 0.1095, 0.05, 0) then
            call sys.printToLog("ThePointer: Steering1 not placed")
            exit function
        end if
        call Steering1.setAngle(0)

        ' initialize XYSensor1
        XYSensor1 = sys.getComponent("XYSensor")
        if XYSensor1 = null then
           call sys.printToLog("ThePointer: XYSensor1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(XYSensor1, "XYSensor", "XYSensor1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(XYSensor1, 0.1095, -0.05, 0) then
            call sys.printToLog("ThePointer: XYSensor1 not placed")
            exit function
        end if

        ' initialize HealthSensor1
        HealthSensor1 = sys.getComponent("HealthSensor")
        if HealthSensor1 = null then
           call sys.printToLog("ThePointer: HealthSensor1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(HealthSensor1, "HealthSensor", "HealthSensor1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(HealthSensor1, 0.0106936, 0.1, 0) then
            call sys.printToLog("ThePointer: HealthSensor1 not placed")
            exit function
        end if
        call HealthSensor1.setCritical_pct(50)
        call HealthSensor1.setHealthy_pct(75)

        ' initialize HealthPack1
        HealthPack1 = sys.getComponent("HealthPack")
        if HealthPack1 = null then
           call sys.printToLog("ThePointer: HealthPack1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(HealthPack1, "HealthPack", "HealthPack1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(HealthPack1, -0.0393064, 0.1, 0) then
            call sys.printToLog("ThePointer: HealthPack1 not placed")
            exit function
        end if

        ' initialize MediumEngine1
        MediumEngine1 = sys.getComponent("MediumEngine")
        if MediumEngine1 = null then
           call sys.printToLog("ThePointer: MediumEngine1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(MediumEngine1, "MediumEngine", "MediumEngine1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(MediumEngine1, -0.0143064, -0.1, 0) then
            call sys.printToLog("ThePointer: MediumEngine1 not placed")
            exit function
        end if
        call MediumEngine1.setThrottle(100)

        ' initialize Divide1
        Divide1 = sys.getComponent("Divide")
        if Divide1 = null then
           call sys.printToLog("ThePointer: Divide1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Divide1, "Divide", "Divide1")
        end if
        ' Logical component doesn't need to be positioned
        call Divide1.setInput1(0)
        call Divide1.setInput2(5)
        call Divide1.setCalc(1)

        ' initialize Add1
        Add1 = sys.getComponent("Add")
        if Add1 = null then
           call sys.printToLog("ThePointer: Add1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Add1, "Add", "Add1")
        end if
        ' Logical component doesn't need to be positioned
        call Add1.setInput1(0)
        call Add1.setInput2(0)

        ' initialize Compare1
        Compare1 = sys.getComponent("Compare")
        if Compare1 = null then
           call sys.printToLog("ThePointer: Compare1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Compare1, "Compare", "Compare1")
        end if
        ' Logical component doesn't need to be positioned
        call Compare1.setInput1(0)
        call Compare1.setInput2(3)
        call Compare1.setCalc(1)

        ' initialize Variable1
        Variable1 = sys.getComponent("Variable")
        if Variable1 = null then
           call sys.printToLog("ThePointer: Variable1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Variable1, "Variable", "Variable1")
        end if
        ' Logical component doesn't need to be positioned
        call Variable1.setInput(0)

        ' initialize RangeTest1
        RangeTest1 = sys.getComponent("RangeTest")
        if RangeTest1 = null then
           call sys.printToLog("ThePointer: RangeTest1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(RangeTest1, "RangeTest", "RangeTest1")
        end if
        ' Logical component doesn't need to be positioned
        call RangeTest1.setMaximum(11)
        call RangeTest1.setMinimum(1)
        call RangeTest1.setInput(0)

        ' initialize Sweeper1
        Sweeper1 = sys.getComponent("Sweeper")
        if Sweeper1 = null then
           call sys.printToLog("ThePointer: Sweeper1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Sweeper1, "Sweeper", "Sweeper1")
        end if
        ' Logical component doesn't need to be positioned
        call Sweeper1.setminAngle(-180)
        call Sweeper1.setmaxAngle(180)
        call Sweeper1.setIncrement(30)
        call Sweeper1.settickTime(0.1)
        call Sweeper1.setAngle(0)

        ' initialize Filter1
        Filter1 = sys.getComponent("Filter")
        if Filter1 = null then
           call sys.printToLog("ThePointer: Filter1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Filter1, "Filter", "Filter1")
        end if
        ' Logical component doesn't need to be positioned
        call Filter1.setEnemyVehicle(1)
        call Filter1.setFilterSocket("")
        call Filter1.setOther(0)
        call Filter1.setProjectile(0)
        call Filter1.setTeammate(0)

        ' initialize Filter2
        Filter2 = sys.getComponent("Filter")
        if Filter2 = null then
           call sys.printToLog("ThePointer: Filter2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Filter2, "Filter", "Filter2")
        end if
        ' Logical component doesn't need to be positioned
        call Filter2.setEnemyVehicle(1)
        call Filter2.setFilterSocket("")
        call Filter2.setOther(0)
        call Filter2.setProjectile(0)
        call Filter2.setTeammate(0)

        ' initialize LogicalTransmitter1
        LogicalTransmitter1 = sys.getComponent("LogicalTransmitter")
        if LogicalTransmitter1 = null then
           call sys.printToLog("ThePointer: LogicalTransmitter1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(LogicalTransmitter1, "LogicalTransmitter", "LogicalTransmitter1")
        end if
        ' Logical component doesn't need to be positioned
        call LogicalTransmitter1.setStation(1)

        ' initialize LogicalTransmitter2
        LogicalTransmitter2 = sys.getComponent("LogicalTransmitter")
        if LogicalTransmitter2 = null then
           call sys.printToLog("ThePointer: LogicalTransmitter2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(LogicalTransmitter2, "LogicalTransmitter", "LogicalTransmitter2")
        end if
        ' Logical component doesn't need to be positioned
        call LogicalTransmitter2.setStation(2)

        ' initialize Variable2
        Variable2 = sys.getComponent("Variable")
        if Variable2 = null then
           call sys.printToLog("ThePointer: Variable2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Variable2, "Variable", "Variable2")
        end if
        ' Logical component doesn't need to be positioned
        call Variable2.setInput(0)

        ' initialize LoopTimer1
        LoopTimer1 = sys.getComponent("LoopTimer")
        if LoopTimer1 = null then
           call sys.printToLog("ThePointer: LoopTimer1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(LoopTimer1, "LoopTimer", "LoopTimer1")
        end if
        ' Logical component doesn't need to be positioned
        call LoopTimer1.setTickTime(0.1)

        ' initialize rectifier1
        rectifier1 = sys.getComponent("rectifier")
        if rectifier1 = null then
           call sys.printToLog("ThePointer: rectifier1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(rectifier1, "rectifier", "rectifier1")
        end if
        ' Logical component doesn't need to be positioned
        call rectifier1.setInput(0)

        ' initialize ModeSwitch1
        ModeSwitch1 = sys.getComponent("ModeSwitch")
        if ModeSwitch1 = null then
           call sys.printToLog("ThePointer: ModeSwitch1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(ModeSwitch1, "ModeSwitch", "ModeSwitch1")
        end if
        ' Logical component doesn't need to be positioned
        call ModeSwitch1.setMode(1)

        ' initialize Subtract1
        Subtract1 = sys.getComponent("Subtract")
        if Subtract1 = null then
           call sys.printToLog("ThePointer: Subtract1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Subtract1, "Subtract", "Subtract1")
        end if
        ' Logical component doesn't need to be positioned
        call Subtract1.setInput1(0)
        call Subtract1.setInput2(45)

        call XYSensor1.Change.register(XYSensor1_Change_wires)
        call HealthSensor1.CriticalDamage.register(HealthSensor1_CriticalDamage_wires)
        call Subtract1.Change.register(Subtract1_Change_wires)
        call Filter1.TurnOn.register(Filter1_TurnOn_wires)
        call Filter1.TurnOff.register(Filter1_TurnOff_wires)
        call rectifier1.Change.register(rectifier1_Change_wires)
        call LoopTimer1.Tick.register(LoopTimer1_Tick_wires)
        call Variable2.Change.register(Variable2_Change_wires)
        call LongRangeRadar1.PlugIn.register(LongRangeRadar1_PlugIn_wires)
        call Sweeper1.Change.register(Sweeper1_Change_wires)
        call Filter2.TurnOn.register(Filter2_TurnOn_wires)
        call Sonar1.PlugIn.register(Sonar1_PlugIn_wires)
        call RangeTest1.AboveRange.register(RangeTest1_AboveRange_wires)
        call Variable1.Change.register(Variable1_Change_wires)
        call Compare1.LessThan.register(Compare1_LessThan_wires)
        call Add1.Change.register(Add1_Change_wires)
        call Divide1.Change.register(Divide1_Change_wires)
        call WaypointSensor1.Change.register(WaypointSensor1_Change_wires)

  ' *** place user initialization here ***
  ' *** end of user initialization ***

        loadComponents = true           ' if we got this far, we succeeded
    end function 'loadComponents

    sub init(sysobj as VehicleSystemObject)
        sys = sysobj
  ' *** place user variable init here ***
  ' *** end of user variable init ***
    end sub 'init

end class 'ThePointer
' END TEMPLATE
